(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@ngx-translate/core'), require('ngx-color-picker'), require('rxjs'), require('rxjs/operators'), require('angular2-promise-buttons/dist'), require('d3')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/forms', '@ngx-translate/core', 'ngx-color-picker', 'rxjs', 'rxjs/operators', 'angular2-promise-buttons/dist', 'd3'], factory) :
	(factory((global.linkular = {}),global['@angular/core'],global['@angular/common'],global['@angular/forms'],global['@ngx-translate/core'],global['ngx-color-picker'],global.rxjs,global['rxjs/operators'],global['angular2-promise-buttons/dist'],global.d3));
}(this, (function (exports,core,common,forms,core$1,ngxColorPicker,rxjs,operators,dist,d3) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_INPUT_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularInputComponent; }),
    multi: true
};
var LinkularInputComponent = /** @class */ (function () {
    function LinkularInputComponent() {
        this.propagateChange = function () { };
        this.placeholder = '';
        this.type = 'text';
        this.label = '';
        this.disable = false;
        this.model = '';
    }
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularInputComponent.prototype.writeValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.model = val;
    };
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularInputComponent.prototype.setValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.propagateChange(val);
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    LinkularInputComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        if (!this.disable && isDisabled !== null) {
            this.disable = isDisabled;
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularInputComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularInputComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    LinkularInputComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-input',
                    template: "<label *ngIf=\"label\" translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <input class=\"u-full-width\" [(ngModel)]=\"model\" (ngModelChange)=\"setValue($event)\" [type]=\"type\" [attr.disabled]=\"(disable) ? true : null\" [placeholder]=\"placeholder | translate\" /> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    styles: [""],
                    providers: [
                        LINKULAR_INPUT_VALUE_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularInputComponent.propDecorators = {
        "placeholder": [{ type: core.Input },],
        "type": [{ type: core.Input },],
        "label": [{ type: core.Input },],
        "errorMsg": [{ type: core.Input },],
        "info": [{ type: core.Input },],
        "disable": [{ type: core.Input },],
    };
    return LinkularInputComponent;
}());

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_WITH_ADDON_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularInputAddonComponent; }),
    multi: true
};
var LinkularInputAddonComponent = /** @class */ (function (_super) {
    __extends(LinkularInputAddonComponent, _super);
    function LinkularInputAddonComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.side = "right";
        _this.icon = false;
        return _this;
    }
    LinkularInputAddonComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-input-with-addon',
                    template: "<label translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <div class=\"form-group\"> <span class=\"input-group-addon\" [class.icon]=\"icon\" *ngIf=\"side === 'left'\"> <ng-content></ng-content> </span> <input class=\"u-full-width\" [(ngModel)]=\"model\"  (ngModelChange)=\"setValue($event)\" [type]=\"type\" [attr.disabled]=\"(disable) ? true : null\" /> <span class=\"input-group-addon\" [class.icon]=\"icon\" *ngIf=\"side === 'right'\"> <ng-content></ng-content> </span> </div> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    styles: [".form-group .input-group-addon.dial-code { background: #d1d1d1; padding: 6px 10px; -webkit-border-radius: 4px 0 0 4px; -moz-border-radius: 4px 0 0 4px; -ms-border-radius: 4px 0 0 4px; border-radius: 4px 0 0 4px; color: rgba(0, 0, 0, 0.8); } .form-group .input-group-addon.dial-code + input { -webkit-border-radius: 0 4px 4px 0; -moz-border-radius: 0 4px 4px 0; -ms-border-radius: 0 4px 4px 0; border-radius: 0 4px 4px 0; } "],
                    providers: [
                        LINKULAR_WITH_ADDON_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularInputAddonComponent.propDecorators = {
        "side": [{ type: core.Input },],
        "icon": [{ type: core.Input },],
    };
    return LinkularInputAddonComponent;
}(LinkularInputComponent));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_CHECKBOX_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularCheckboxComponent; }),
    multi: true
};
var LinkularCheckboxComponent = /** @class */ (function () {
    function LinkularCheckboxComponent() {
        this.propagateChange = function () { };
        this.model = '';
        this.placeholder = '';
        this.label = '';
        this.disable = false;
        this.callback = new core.EventEmitter();
        this.callbackAction = false;
    }
    /**
     * @return {?}
     */
    LinkularCheckboxComponent.prototype.onClick = /**
     * @return {?}
     */
    function () {
        if (!this.disable) {
            this.model = !this.model;
            this.setValue(this.model);
        }
    };
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularCheckboxComponent.prototype.writeValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.model = val;
    };
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularCheckboxComponent.prototype.setValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.propagateChange(val);
        this.handleCallback();
    };
    /**
     * @return {?}
     */
    LinkularCheckboxComponent.prototype.handleCallback = /**
     * @return {?}
     */
    function () {
        if (this.callbackAction) {
            this.callback.emit();
        }
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    LinkularCheckboxComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        if (!this.disable && isDisabled !== null) {
            this.disable = isDisabled;
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularCheckboxComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularCheckboxComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    /**
     * @return {?}
     */
    LinkularCheckboxComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.callbackAction = this.callback.observers.length > 0;
    };
    LinkularCheckboxComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-checkbox',
                    template: " <div class=\"linkular-checkbox\"> <svg *ngIf=\"model\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" viewBox=\"0 0 200 200\"> <path d=\"M159.25,39.68a9.22,9.22,0,0,0-13,0l-75,75L53.78,97.23a9.23,9.23,0,0,0-13,0l-13,13a9.21,9.21,0,0,0,0,13l24,24,13,13a9.22,9.22,0,0,0,13,0L172.3,65.76a9.22,9.22,0,0,0,0-13Zm0,0\"/> </svg> </div> <label *ngIf=\"label\" translate>{{label}}</label> ",
                    styles: [":host { position: relative; display: block; margin-bottom: 15px; height: 38px; cursor: pointer; } :host::before, :host::after { content: \" \"; display: table; clear: both; } :host label, :host .linkular-checkbox { display: block; float: left; } :host .linkular-checkbox { margin: 9px 0; width: 20px; height: 20px; border: 1px solid black; position: relative; } :host .linkular-checkbox svg { height: 18px; width: 18px; display: block; position: absolute; top: 0; left: 0; } :host .linkular-checkbox + label { margin-left: 5px; } :host label { line-height: 38px; cursor: pointer; } :host.disabled { opacity: .6; cursor: not-allowed; } :host.disabled label { cursor: not-allowed; } "],
                    providers: [
                        LINKULAR_CHECKBOX_VALUE_ACCESSOR
                    ],
                    host: {
                        '[class.disabled]': 'disable'
                    }
                },] },
    ];
    /** @nocollapse */
    LinkularCheckboxComponent.propDecorators = {
        "onClick": [{ type: core.HostListener, args: ['click',] },],
        "placeholder": [{ type: core.Input },],
        "label": [{ type: core.Input },],
        "errorMsg": [{ type: core.Input },],
        "disable": [{ type: core.Input },],
        "callback": [{ type: core.Output },],
    };
    return LinkularCheckboxComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_TEXTAREA_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularTextareaComponent; }),
    multi: true
};
var LinkularTextareaComponent = /** @class */ (function () {
    function LinkularTextareaComponent() {
        this.propagateChange = function () { };
        this.placeholder = '';
        this.type = 'text';
        this.label = '';
        this.isSMS = false;
        this.disable = false;
        this.model = '';
        this.sms = 1;
        this.char = 0;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularTextareaComponent.prototype.writeValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        if (this.sms) {
            this.calculate(val, true);
        }
        this.model = val;
    };
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularTextareaComponent.prototype.setValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        if (this.sms) {
            this.calculate(val);
        }
        this.propagateChange(val);
    };
    /**
     * @param {?} val
     * @param {?=} init
     * @return {?}
     */
    LinkularTextareaComponent.prototype.calculate = /**
     * @param {?} val
     * @param {?=} init
     * @return {?}
     */
    function (val, init) {
        var _this = this;
        this.char = this.calculateChar(val);
        this.sms = this.calculateSMS(this.char);
        this.adjust();
        setTimeout(function () {
            _this.adjust();
        }, (init) ? 150 : 0);
    };
    /**
     * @param {?} amount
     * @return {?}
     */
    LinkularTextareaComponent.prototype.calculateSMS = /**
     * @param {?} amount
     * @return {?}
     */
    function (amount) {
        var /** @type {?} */ output = 1;
        if (amount > 160) {
            output = Math.ceil(amount / 153);
        }
        return output;
    };
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularTextareaComponent.prototype.calculateChar = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        var /** @type {?} */ output = 0;
        if (val && val.length > 0) {
            output = val.split('').reduce(function (sum, el) {
                var /** @type {?} */ localVal = 1;
                switch (el) {
                    case '[':
                    case ']':
                    case '\\':
                    case '^':
                    case '{':
                    case '}':
                    case '|':
                    case '€':
                        localVal = 2;
                        break;
                    default:
                        localVal = 1;
                }
                return sum + localVal;
            }, 0);
        }
        return output;
    };
    /**
     * @return {?}
     */
    LinkularTextareaComponent.prototype.adjust = /**
     * @return {?}
     */
    function () {
        this.textareaEl.nativeElement.style.overflow = 'hidden';
        this.textareaEl.nativeElement.style.height = 'auto';
        this.textareaEl.nativeElement.style.height = this.textareaEl.nativeElement.scrollHeight + 'px';
    };
    /**
     * @param {?} e
     * @return {?}
     */
    LinkularTextareaComponent.prototype.onResize = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (this.isSMS) {
            this.adjust();
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularTextareaComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularTextareaComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    LinkularTextareaComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        if (!this.disable && isDisabled !== null) {
            this.disable = isDisabled;
        }
    };
    LinkularTextareaComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-textarea',
                    template: "<label translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <div class=\"linkular-textarea\"> <textarea class=\"u-full-width\" #linkTextarea [class.linkular-sms]=\"isSMS\" [(ngModel)]=\"model\" (ngModelChange)=\"setValue($event)\" [placeholder]=\"placeholder | translate\" [attr.disabled]=\"(disable) ? true : null\"></textarea> <sms-counter *ngIf=\"isSMS\" [sms]=\"sms\" [char]=\"char\"></sms-counter> </div> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    styles: [".linkular-textarea { position: relative; display: block; width: 100%; } .linkular-textarea textarea { min-height: 80px; resize: none; } .linkular-textarea textarea.linkular-sms { padding-bottom: 30px; } "],
                    providers: [
                        LINKULAR_TEXTAREA_VALUE_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularTextareaComponent.propDecorators = {
        "placeholder": [{ type: core.Input },],
        "type": [{ type: core.Input },],
        "label": [{ type: core.Input },],
        "errorMsg": [{ type: core.Input },],
        "info": [{ type: core.Input },],
        "isSMS": [{ type: core.Input },],
        "disable": [{ type: core.Input },],
        "textareaEl": [{ type: core.ViewChild, args: ['linkTextarea',] },],
        "onResize": [{ type: core.HostListener, args: ['window:resize', ['$event'],] },],
    };
    return LinkularTextareaComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SMSCounterComponent = /** @class */ (function () {
    function SMSCounterComponent() {
        this.sms = 0;
        this.char = 0;
    }
    SMSCounterComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'sms-counter',
                    styles: [":host { position: absolute; right: 10px; bottom: 18px; } :host .sms-count-el { display: block; float: left; margin-left: 10px; } :host .sms-count-el svg.sms-count-icon, :host .sms-count-el .sms-count-amount { display: block; float: left; } :host .sms-count-el svg.sms-count-icon { width: 30px; height: 30px; display: block; } :host .sms-count-el svg.sms-count-icon path { fill: #d1d1d1; } :host .sms-count-el .sms-count-amount { margin: 0 0 0 -5px; min-width: 24px; display: block; height: 30px; text-align: center; font-size: 12px; line-height: 22px; padding: 4px; font-weight: bold; color: #d1d1d1; box-sizing: border-box; -webkit-border-radius: 15px; -moz-border-radius: 15px; -ms-border-radius: 15px; border-radius: 15px; } :host .sms-count-el .sms-count-amount.large { min-width: 40px; } "],
                    template: "<div class=\"sms-count-el\"> <svg class=\"sms-count-icon\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 200 200\"> <path d=\"M100.25,159.5H67.87v-3.9A33.59,33.59,0,0,0,75,154.5q2.83-.82,2.83-2a8.26,8.26,0,0,0-.11-1.21,5.86,5.86,0,0,0-.33-1.26l-6.45-17.46H43.58q-1.54,3.84-2.5,6.7t-1.73,5.27a37.5,37.5,0,0,0-1,3.84,13.85,13.85,0,0,0-.27,2.42q0,2.2,3.46,3.4a27.84,27.84,0,0,0,7.8,1.43v3.9H20v-3.9a23,23,0,0,0,3.57-.63,11.6,11.6,0,0,0,3.51-1.4,13.86,13.86,0,0,0,3.4-3.1A20.33,20.33,0,0,0,32.84,146q5.87-14.66,13-32.93T58.42,80.51h4.39l26,67.19a13.21,13.21,0,0,0,1.87,3.46,12.85,12.85,0,0,0,2.91,2.58A12.19,12.19,0,0,0,96.85,155a16.76,16.76,0,0,0,3.4.58ZM68.91,127.66,57.12,97.44,45.49,127.66Zm106,25.1a18.37,18.37,0,0,1-5-1.94,19.36,19.36,0,0,1-4.38-3.89,19.9,19.9,0,0,1-2.81-5.21L123.6,40.5H117q-8.35,21.5-19,49Q92,105,86.59,118.66l4.14,10.7.13-.38q1.45-4.3,3.77-10.09h41.19l9.72,26.3a8.84,8.84,0,0,1,.5,1.9,12.45,12.45,0,0,1,.17,1.82q0,1.82-4.26,3.06a50.6,50.6,0,0,1-10.71,1.65v5.87H180v-5.87A25.25,25.25,0,0,1,174.87,152.76ZM97.5,111.54,115,66l17.77,45.54Z\"/> </svg> <div class=\"sms-count-amount large\">{{char}}</div> </div> <div class=\"sms-count-el\"> <svg class=\"sms-count-icon\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 200 200\"> <path d=\"M169.44,47.06H30.56A5.56,5.56,0,0,0,25,52.62v94.77a5.56,5.56,0,0,0,5.56,5.56H169.44a5.56,5.56,0,0,0,5.56-5.56V52.62a5.56,5.56,0,0,0-5.56-5.56ZM36.12,63.14,73.89,88.92,36.12,132.48ZM100,93.27,48.57,58.18H151.43Zm-16.86,2,13.73,9.37a5.56,5.56,0,0,0,6.27,0l13.73-9.37,40.4,46.6H42.74Zm43-6.31,37.77-25.77v69.33Zm0,0\"/> </svg> <div class=\"sms-count-amount\">{{sms}}</div> </div> "
                },] },
    ];
    /** @nocollapse */
    SMSCounterComponent.propDecorators = {
        "sms": [{ type: core.Input },],
        "char": [{ type: core.Input },],
    };
    return SMSCounterComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_SELECT_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularSelectComponent; }),
    multi: true
};
var LinkularSelectComponent = /** @class */ (function () {
    function LinkularSelectComponent(el) {
        this.el = el;
        this.propagateChange = function () { };
        this.opened = false;
        this.icon = 'caret-down';
        this.list = [];
        this.label = '';
        this.disable = false;
        this.callback = new core.EventEmitter();
        this.callbackAction = false;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    LinkularSelectComponent.prototype.onClick = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (this.opened && !this.el.nativeElement.contains(event.target)) {
            this.opened = false;
        }
    };
    Object.defineProperty(LinkularSelectComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () {
            return this._value;
        },
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            if (this._value !== val) {
                this._value = val;
                this.propagateChange(val);
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularSelectComponent.prototype.writeValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        if (val) {
            this.selectValue(val, true);
        }
    };
    /**
     * @param {?} val
     * @param {?} init
     * @return {?}
     */
    LinkularSelectComponent.prototype.selectValue = /**
     * @param {?} val
     * @param {?} init
     * @return {?}
     */
    function (val, init) {
        var _this = this;
        var /** @type {?} */ selectedValue;
        if (!this.saveBy) {
            selectedValue = val;
        }
        else {
            // tslint:disable-next-line:max-line-length
            selectedValue = this.list.find(function (item) { return (_this.saveBy) ? (item[_this.saveBy] === val) : ((_this.checkBy) ? (item[_this.checkBy] === val[_this.checkBy]) : item === val); });
        }
        setTimeout(function () {
            if (selectedValue === undefined && _this.list.length > 0) {
                selectedValue = _this.list[0];
            }
            if (selectedValue) {
                _this.fullValue = selectedValue;
                var /** @type {?} */ temp = (_this.saveBy) ? selectedValue[_this.saveBy] : selectedValue;
                if (!init) {
                    _this.value = temp;
                }
                else {
                    _this._value = temp;
                }
            }
            _this.handleCallback(_this.fullValue);
        }, 150);
    };
    /**
     * @param {?} full
     * @return {?}
     */
    LinkularSelectComponent.prototype.handleCallback = /**
     * @param {?} full
     * @return {?}
     */
    function (full) {
        if (this.callbackAction) {
            this.callback.emit(full);
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularSelectComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularSelectComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        // do nothing
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    LinkularSelectComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        if (!this.disable && isDisabled !== null) {
            this.disable = isDisabled;
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    LinkularSelectComponent.prototype.select = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        if (!this.disable && item) {
            this.fullValue = item;
            this.value = (this.saveBy) ? item[this.saveBy] : item;
            this.handleCallback(item);
        }
        this.opened = false;
        this.icon = 'caret-down';
    };
    /**
     * @return {?}
     */
    LinkularSelectComponent.prototype.toggle = /**
     * @return {?}
     */
    function () {
        if (!this.disable) {
            this.opened = !this.opened;
            this.icon = (this.opened) ? 'caret-up' : 'caret-down';
        }
    };
    /**
     * @return {?}
     */
    LinkularSelectComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.callbackAction = this.callback.observers.length > 0;
    };
    LinkularSelectComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-select',
                    template: "<label *ngIf=\"label\" translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <div class=\"linkular-select\" [class.opened]=\"opened\" [class.disabled]=\"disable\"> <button type=\"button\" class=\"linkular-select-button\" (click)=\"toggle()\"> <span *ngIf=\"!nameBy\">{{_value}}</span> <span *ngIf=\"nameBy && fullValue\">{{fullValue[nameBy]}}</span> <span *ngIf=\"(!nameBy || !fullValue) && placeholder\" translate>{{placeholder}}</span> <svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" viewBox=\"0 0 200 200\"> <path *ngIf=\"icon === 'caret-up'\" d=\"M43.59,122.3a4.1,4.1,0,0,0,5.8,0l51-51.1,51.1,51.1a4.1,4.1,0,1,0,5.8-5.8l-53.9-53.9a4,4,0,0,0-2.9-1.2,4.18,4.18,0,0,0-2.9,1.2l-53.9,53.9A4,4,0,0,0,43.59,122.3Z\"/> <path *ngIf=\"icon === 'caret-down'\" d=\"M157.3,78.6a4.1,4.1,0,0,0-5.8,0l-51,51.1L49.4,78.6a4.1,4.1,0,1,0-5.8,5.8l53.9,53.9a4,4,0,0,0,2.9,1.2,4.18,4.18,0,0,0,2.9-1.2l53.9-53.9A4,4,0,0,0,157.3,78.6Z\"/> </svg> </button> <ul class=\"linkular-select-list\" *ngIf=\"list && list.length > 0\"> <li class=\"select-option\" [class.selected]=\"(saveBy && fullValue && el[saveBy] === fullValue[saveBy]) || (checkBy && fullValue && el[checkBy] === fullValue[checkBy]) || el === _value\" *ngFor=\"let el of list\" (click)=\"select(el)\"> <span *ngIf=\"!nameBy\">{{el}}</span> <span *ngIf=\"nameBy\">{{el[nameBy]}}</span> </li> </ul> </div> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    styles: [".linkular-select { position: relative; display: block; width: 100%; margin-bottom: 15px; height: 38px; } .linkular-select button.linkular-select-button { background: white; color: black; text-align: left; margin-bottom: 0; padding: 0 26px 0 0.6rem; width: 100%; cursor: pointer; overflow: hidden; } .linkular-select button.linkular-select-button span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select button.linkular-select-button svg { width: 26px; height: 38px; padding: 8px 2px; opacity: 1; position: absolute; right: 0; top: 0; box-sizing: border-box; } .linkular-select button.linkular-select-button:focus, .linkular-select button.linkular-select-button:active, .linkular-select button.linkular-select-button:hover { border: 1px solid #d1d1d1; } .linkular-select.disabled button.linkular-select-button { background: #f5f5f5; color: #4d4d4d; cursor: default; } .linkular-select.disabled button.linkular-select-button svg { fill: #4d4d4d; } .linkular-select ul.linkular-select-list { margin-top: -1px; display: none; position: absolute; list-style: none; background-color: white; width: 100%; max-height: 280px; overflow-y: auto; z-index: 5; top: 38px; border: 1px solid #d1d1d1; -webkit-border-radius: 4px; -moz-border-radius: 4px; -ms-border-radius: 4px; border-radius: 4px; -webkit-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); -moz-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); } .linkular-select ul.linkular-select-list li { padding: 0 .6rem; } .linkular-select ul.linkular-select-list li { color: black; margin: 0; width: 100%; display: block; font-size: 11px; font-weight: 600; line-height: 38px; height: 38px; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; background-color: transparent; border-bottom: 1px solid #d1d1d1; cursor: pointer; box-sizing: border-box; overflow: hidden; } .linkular-select ul.linkular-select-list li span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select ul.linkular-select-list li.selected { background: #1DE9B6; color: white; } .linkular-select ul.linkular-select-list li:last-child { border-bottom: none; } .linkular-select.opened ul.linkular-select-list { display: block; } .linkular-select.opened button.linkular-select-button { border: 1px solid #d1d1d1; } "],
                    providers: [
                        LINKULAR_SELECT_VALUE_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularSelectComponent.ctorParameters = function () { return [
        { type: core.ElementRef, },
    ]; };
    LinkularSelectComponent.propDecorators = {
        "onClick": [{ type: core.HostListener, args: ['click', ['$event'],] },],
        "list": [{ type: core.Input },],
        "placeholder": [{ type: core.Input },],
        "label": [{ type: core.Input },],
        "errorMsg": [{ type: core.Input },],
        "info": [{ type: core.Input },],
        "disable": [{ type: core.Input },],
        "saveBy": [{ type: core.Input },],
        "nameBy": [{ type: core.Input },],
        "checkBy": [{ type: core.Input },],
        "callback": [{ type: core.Output },],
    };
    return LinkularSelectComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var languages = [
    { 'name': 'Afrikaans', 'nativeName': 'Afrikaans', 'code': 'af' },
    { 'name': 'Albanian', 'nativeName': 'Shqip', 'code': 'sq' },
    { 'name': 'Aragonese', 'nativeName': 'Aragonés', 'code': 'an' },
    { 'name': 'Armenian', 'nativeName': 'Հայերեն', 'code': 'hy' },
    { 'name': 'Azerbaijani', 'nativeName': 'azərbaycan dili', 'code': 'az' },
    { 'name': 'Basque', 'nativeName': 'euskara, euskera', 'code': 'eu' },
    { 'name': 'Belarusian', 'nativeName': 'Беларуская', 'code': 'be' },
    { 'name': 'Bosnian', 'nativeName': 'bosanski jezik', 'code': 'bs' },
    { 'name': 'Breton', 'nativeName': 'brezhoneg', 'code': 'br' },
    { 'name': 'Bulgarian', 'nativeName': 'български език', 'code': 'bg' },
    { 'name': 'Catalan; Valencian', 'nativeName': 'Català', 'code': 'ca' },
    { 'name': 'Chinese', 'nativeName': '中文 (Zhōngwén), 汉语, 漢語', 'code': 'zh' },
    { 'name': 'Corsican', 'nativeName': 'corsu, lingua corsa', 'code': 'co' },
    { 'name': 'Croatian', 'nativeName': 'hrvatski', 'code': 'hr' },
    { 'name': 'Czech', 'nativeName': 'česky, čeština', 'code': 'cs' },
    { 'name': 'Danish', 'nativeName': 'dansk', 'code': 'da' },
    { 'name': 'Dutch', 'nativeName': 'Nederlands, Vlaams', 'code': 'nl' },
    { 'name': 'English', 'nativeName': 'English', 'code': 'en' },
    { 'name': 'Estonian', 'nativeName': 'eesti, eesti keel', 'code': 'et' },
    { 'name': 'Faroese', 'nativeName': 'føroyskt', 'code': 'fo' },
    { 'name': 'Fijian', 'nativeName': 'vosa Vakaviti', 'code': 'fj' },
    { 'name': 'Finnish', 'nativeName': 'suomi, suomen kieli', 'code': 'fi' },
    { 'name': 'French', 'nativeName': 'français, langue française', 'code': 'fr' },
    { 'name': 'Georgian', 'nativeName': 'ქართული', 'code': 'ka' },
    { 'name': 'German', 'nativeName': 'Deutsch', 'code': 'de' },
    { 'name': 'Greek', 'nativeName': 'Ελληνικά', 'code': 'el' },
    { 'name': 'Hebrew (modern)', 'nativeName': 'עברית', 'code': 'he' },
    { 'name': 'Hindi', 'nativeName': 'हिन्दी, हिंदी', 'code': 'hi' },
    { 'name': 'Hungarian', 'nativeName': 'Magyar', 'code': 'hu' },
    { 'name': 'Irish', 'nativeName': 'Gaeilge', 'code': 'ga' },
    { 'name': 'Icelandic', 'nativeName': 'Íslenska', 'code': 'is' },
    { 'name': 'Italian', 'nativeName': 'Italiano', 'code': 'it' },
    { 'name': 'Japanese', 'nativeName': '日本語 (にほんご／にっぽんご)', 'code': 'ja' },
    { 'name': 'Kalaallisut, Greenlandic', 'nativeName': 'kalaallisut, kalaallit oqaasii', 'code': 'kl' },
    { 'name': 'Kazakh', 'nativeName': 'Қазақ тілі', 'code': 'kk' },
    { 'name': 'Korean', 'nativeName': '한국어 (韓國語), 조선말 (朝鮮語)', 'code': 'ko' },
    { 'name': 'Luxembourgish, Letzeburgesch', 'nativeName': 'Lëtzebuergesch', 'code': 'lb' },
    { 'name': 'Lithuanian', 'nativeName': 'lietuvių kalba', 'code': 'lt' },
    { 'name': 'Latvian', 'nativeName': 'latviešu valoda', 'code': 'lv' },
    { 'name': 'Macedonian', 'nativeName': 'македонски јазик', 'code': 'mk' },
    { 'name': 'Maltese', 'nativeName': 'Malti', 'code': 'mt' },
    { 'name': 'Mongolian', 'nativeName': 'монгол', 'code': 'mn' },
    { 'name': 'Norwegian', 'nativeName': 'Norsk', 'code': 'no' },
    { 'name': 'Polish', 'nativeName': 'polski', 'code': 'pl' },
    { 'name': 'Portuguese', 'nativeName': 'Português', 'code': 'pt' },
    { 'name': 'Romanian', 'nativeName': 'română', 'code': 'ro' },
    { 'name': 'Russian', 'nativeName': 'русский язык', 'code': 'ru' },
    { 'name': 'Serbian', 'nativeName': 'српски језик', 'code': 'sr' },
    { 'name': 'Scottish Gaelic; Gaelic', 'nativeName': 'Gàidhlig', 'code': 'gd' },
    { 'name': 'Slovak', 'nativeName': 'slovenčina', 'code': 'sk' },
    { 'name': 'Slovene', 'nativeName': 'slovenščina', 'code': 'sl' },
    { 'name': 'Spanish; Castilian', 'nativeName': 'español, castellano', 'code': 'es' },
    { 'name': 'Swedish', 'nativeName': 'svenska', 'code': 'sv' },
    { 'name': 'Thai', 'nativeName': 'ไทย', 'code': 'th' },
    { 'name': 'Turkish', 'nativeName': 'Türkçe', 'code': 'tr' },
    { 'name': 'Ukrainian', 'nativeName': 'українська', 'code': 'uk' },
    { 'name': 'Welsh', 'nativeName': 'Cymraeg', 'code': 'cy' }
];
/**
 * @record
 */

var __extends$1 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_SELECT_LANGUAGE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularSelectLanguageComponent; }),
    multi: true
};
var LinkularSelectLanguageComponent = /** @class */ (function (_super) {
    __extends$1(LinkularSelectLanguageComponent, _super);
    function LinkularSelectLanguageComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.languagesList = languages.slice();
        _this.saveBy = 'code';
        _this.nameBy = 'name';
        _this.all = false;
        _this.full = false;
        return _this;
    }
    /**
     * @param {?} item
     * @return {?}
     */
    LinkularSelectLanguageComponent.prototype.select = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        if (!this.disable && item) {
            this.fullValue = item;
            this.value = (this.full) ? item : item.code;
            this.handleCallback(item);
        }
        this.opened = false;
        this.icon = 'caret-down';
    };
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularSelectLanguageComponent.prototype.selectValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        var _this = this;
        var /** @type {?} */ selectedValue;
        var /** @type {?} */ check = (this.full && val.id) ? val.name : val;
        selectedValue = this.languagesList.find(function (item) { return item.code === check; });
        setTimeout(function () {
            if (selectedValue === undefined && _this.languagesList.length > 0) {
                selectedValue = _this.languagesList[0];
            }
            if (selectedValue) {
                _this.fullValue = selectedValue;
                _this.value = (_this.full) ? selectedValue : selectedValue.code;
            }
            _this.handleCallback(_this.fullValue);
        }, 150);
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    LinkularSelectLanguageComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        var _loop_1 = function (propName) {
            if (propName === 'list') {
                var /** @type {?} */ change = changes[propName];
                var /** @type {?} */ tempLanguages_1 = languages.slice();
                this_1.languagesList = change.currentValue.map(function (code) { return tempLanguages_1.find(function (x) { return x.code === code; }); });
            }
        };
        var this_1 = this;
        for (var /** @type {?} */ propName in changes) {
            _loop_1(propName);
        }
    };
    LinkularSelectLanguageComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-select-language',
                    template: "<label translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <div class=\"linkular-select\" [class.opened]=\"opened\" [class.disabled]=\"disable\"> <button type=\"button\" class=\"linkular-select-button\" (click)=\"toggle()\"> <span *ngIf=\"fullValue\">{{fullValue.name}}</span> <span *ngIf=\"!fullValue && placeholder\" translate>{{placeholder}}</span> <svg *ngIf=\"(!fullValue && languagesList.length > 0) || (fullValue && languagesList.length > 1)\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" viewBox=\"0 0 200 200\"> <path *ngIf=\"icon === 'caret-up'\" d=\"M43.59,122.3a4.1,4.1,0,0,0,5.8,0l51-51.1,51.1,51.1a4.1,4.1,0,1,0,5.8-5.8l-53.9-53.9a4,4,0,0,0-2.9-1.2,4.18,4.18,0,0,0-2.9,1.2l-53.9,53.9A4,4,0,0,0,43.59,122.3Z\" /> <path *ngIf=\"icon === 'caret-down'\" d=\"M157.3,78.6a4.1,4.1,0,0,0-5.8,0l-51,51.1L49.4,78.6a4.1,4.1,0,1,0-5.8,5.8l53.9,53.9a4,4,0,0,0,2.9,1.2,4.18,4.18,0,0,0,2.9-1.2l53.9-53.9A4,4,0,0,0,157.3,78.6Z\" /> </svg> </button> <ul class=\"linkular-select-list\" *ngIf=\"(!fullValue && languagesList.length > 0) || (fullValue && languagesList.length > 1)\"> <li class=\"select-option\" [class.selected]=\"fullValue && el.code === fullValue.code\" *ngFor=\"let el of languagesList\" (click)=\"select(el)\"> <span>{{el.name}}</span> </li> </ul> </div> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    styles: [".linkular-select { position: relative; display: block; width: 100%; margin-bottom: 15px; height: 38px; } .linkular-select button.linkular-select-button { background: white; color: black; text-align: left; margin-bottom: 0; padding: 0 26px 0 0.6rem; width: 100%; cursor: pointer; overflow: hidden; } .linkular-select button.linkular-select-button span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select button.linkular-select-button svg { width: 26px; height: 38px; padding: 8px 2px; opacity: 1; position: absolute; right: 0; top: 0; box-sizing: border-box; } .linkular-select button.linkular-select-button:focus, .linkular-select button.linkular-select-button:active, .linkular-select button.linkular-select-button:hover { border: 1px solid #d1d1d1; } .linkular-select.disabled button.linkular-select-button { background: #f5f5f5; color: #4d4d4d; cursor: default; } .linkular-select.disabled button.linkular-select-button svg { fill: #4d4d4d; } .linkular-select ul.linkular-select-list { margin-top: -1px; display: none; position: absolute; list-style: none; background-color: white; width: 100%; max-height: 280px; overflow-y: auto; z-index: 5; top: 38px; border: 1px solid #d1d1d1; -webkit-border-radius: 4px; -moz-border-radius: 4px; -ms-border-radius: 4px; border-radius: 4px; -webkit-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); -moz-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); } .linkular-select ul.linkular-select-list li { padding: 0 .6rem; } .linkular-select ul.linkular-select-list li { color: black; margin: 0; width: 100%; display: block; font-size: 11px; font-weight: 600; line-height: 38px; height: 38px; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; background-color: transparent; border-bottom: 1px solid #d1d1d1; cursor: pointer; box-sizing: border-box; overflow: hidden; } .linkular-select ul.linkular-select-list li span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select ul.linkular-select-list li.selected { background: #1DE9B6; color: white; } .linkular-select ul.linkular-select-list li:last-child { border-bottom: none; } .linkular-select.opened ul.linkular-select-list { display: block; } .linkular-select.opened button.linkular-select-button { border: 1px solid #d1d1d1; } "],
                    providers: [
                        LINKULAR_SELECT_LANGUAGE_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularSelectLanguageComponent.propDecorators = {
        "all": [{ type: core.Input },],
        "full": [{ type: core.Input },],
    };
    return LinkularSelectLanguageComponent;
}(LinkularSelectComponent));

var __extends$2 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_SELECT_LANGUAGE2_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularSelectLanguage2Component; }),
    multi: true
};
var LinkularSelectLanguage2Component = /** @class */ (function (_super) {
    __extends$2(LinkularSelectLanguage2Component, _super);
    function LinkularSelectLanguage2Component() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.lang = {};
        return _this;
    }
    /**
     * @return {?}
     */
    LinkularSelectLanguage2Component.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ d = {};
        languages.forEach(function (x) { return d[x.code] = x; });
        this.lang = d;
    };
    LinkularSelectLanguage2Component.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-select-language2',
                    template: "<label translate>{{label}} <span *ngIf=\"info\" translate>{{info}}</span> </label> <div class=\"linkular-select\" [class.opened]=\"opened\" [class.disabled]=\"disable\"> <button type=\"button\" class=\"linkular-select-button\" (click)=\"toggle()\"> <span *ngIf=\"fullValue\">{{lang[fullValue.name].name}}</span> <span *ngIf=\"!fullValue && placeholder\" translate>{{placeholder}}</span> <svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" viewBox=\"0 0 200 200\"> <path *ngIf=\"icon === 'caret-up'\" d=\"M43.59,122.3a4.1,4.1,0,0,0,5.8,0l51-51.1,51.1,51.1a4.1,4.1,0,1,0,5.8-5.8l-53.9-53.9a4,4,0,0,0-2.9-1.2,4.18,4.18,0,0,0-2.9,1.2l-53.9,53.9A4,4,0,0,0,43.59,122.3Z\" /> <path *ngIf=\"icon === 'caret-down'\" d=\"M157.3,78.6a4.1,4.1,0,0,0-5.8,0l-51,51.1L49.4,78.6a4.1,4.1,0,1,0-5.8,5.8l53.9,53.9a4,4,0,0,0,2.9,1.2,4.18,4.18,0,0,0,2.9-1.2l53.9-53.9A4,4,0,0,0,157.3,78.6Z\" /> </svg> </button> <ul class=\"linkular-select-list\"> <li class=\"select-option\" [class.selected]=\"fullValue && el.name === fullValue.name\" *ngFor=\"let el of list\" (click)=\"select(el)\"> <span>{{lang[el.name].name}}</span> </li> </ul> </div> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p>",
                    styles: [".linkular-select { position: relative; display: block; width: 100%; margin-bottom: 15px; height: 38px; } .linkular-select button.linkular-select-button { background: white; color: black; text-align: left; margin-bottom: 0; padding: 0 26px 0 0.6rem; width: 100%; cursor: pointer; overflow: hidden; } .linkular-select button.linkular-select-button span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select button.linkular-select-button svg { width: 26px; height: 38px; padding: 8px 2px; opacity: 1; position: absolute; right: 0; top: 0; box-sizing: border-box; } .linkular-select button.linkular-select-button:focus, .linkular-select button.linkular-select-button:active, .linkular-select button.linkular-select-button:hover { border: 1px solid #d1d1d1; } .linkular-select.disabled button.linkular-select-button { background: #f5f5f5; color: #4d4d4d; cursor: default; } .linkular-select.disabled button.linkular-select-button svg { fill: #4d4d4d; } .linkular-select ul.linkular-select-list { margin-top: -1px; display: none; position: absolute; list-style: none; background-color: white; width: 100%; max-height: 280px; overflow-y: auto; z-index: 5; top: 38px; border: 1px solid #d1d1d1; -webkit-border-radius: 4px; -moz-border-radius: 4px; -ms-border-radius: 4px; border-radius: 4px; -webkit-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); -moz-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); } .linkular-select ul.linkular-select-list li { padding: 0 .6rem; } .linkular-select ul.linkular-select-list li { color: black; margin: 0; width: 100%; display: block; font-size: 11px; font-weight: 600; line-height: 38px; height: 38px; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; background-color: transparent; border-bottom: 1px solid #d1d1d1; cursor: pointer; box-sizing: border-box; overflow: hidden; } .linkular-select ul.linkular-select-list li span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select ul.linkular-select-list li.selected { background: #1DE9B6; color: white; } .linkular-select ul.linkular-select-list li:last-child { border-bottom: none; } .linkular-select.opened ul.linkular-select-list { display: block; } .linkular-select.opened button.linkular-select-button { border: 1px solid #d1d1d1; } "],
                    providers: [
                        LINKULAR_SELECT_LANGUAGE2_ACCESSOR
                    ],
                    host: {
                        '(document:click)': 'onClick($event)',
                    }
                },] },
    ];
    return LinkularSelectLanguage2Component;
}(LinkularSelectComponent));

var __extends$3 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_SELECT_TRANSLATE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularSelectTranslateComponent; }),
    multi: true
};
var LinkularSelectTranslateComponent = /** @class */ (function (_super) {
    __extends$3(LinkularSelectTranslateComponent, _super);
    function LinkularSelectTranslateComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.translationPrefix = "";
        return _this;
    }
    LinkularSelectTranslateComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-select-translate',
                    template: "<label *ngIf=\"label\" translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <div class=\"linkular-select\" [class.opened]=\"opened\" [class.disabled]=\"disable\"> <button type=\"button\" class=\"linkular-select-button\" (click)=\"toggle()\"> <span *ngIf=\"!nameBy && fullValue\" translate>{{translationPrefix}}{{_value}}</span> <span *ngIf=\"nameBy && fullValue\" translate>{{translationPrefix}}{{fullValue[nameBy]}}</span> <span *ngIf=\"(!nameBy || !fullValue) && placeholder\" translate>{{placeholder}}</span> <svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" viewBox=\"0 0 200 200\"> <path *ngIf=\"icon === 'caret-up'\" d=\"M43.59,122.3a4.1,4.1,0,0,0,5.8,0l51-51.1,51.1,51.1a4.1,4.1,0,1,0,5.8-5.8l-53.9-53.9a4,4,0,0,0-2.9-1.2,4.18,4.18,0,0,0-2.9,1.2l-53.9,53.9A4,4,0,0,0,43.59,122.3Z\"/> <path *ngIf=\"icon === 'caret-down'\" d=\"M157.3,78.6a4.1,4.1,0,0,0-5.8,0l-51,51.1L49.4,78.6a4.1,4.1,0,1,0-5.8,5.8l53.9,53.9a4,4,0,0,0,2.9,1.2,4.18,4.18,0,0,0,2.9-1.2l53.9-53.9A4,4,0,0,0,157.3,78.6Z\"/> </svg> </button> <ul class=\"linkular-select-list\" *ngIf=\"list && list.length > 0\"> <li class=\"select-option\" [class.selected]=\"(saveBy && fullValue && el[saveBy] === fullValue[saveBy]) || (checkBy && fullValue && el[checkBy] === fullValue[checkBy]) || el === _value\" *ngFor=\"let el of list\" (click)=\"select(el)\"> <span *ngIf=\"!nameBy\" translate>{{translationPrefix}}{{el}}</span> <span *ngIf=\"nameBy\" translate>{{translationPrefix}}{{el[nameBy]}}</span> </li> </ul> </div> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    styles: [".linkular-select { position: relative; display: block; width: 100%; margin-bottom: 15px; height: 38px; } .linkular-select button.linkular-select-button { background: white; color: black; text-align: left; margin-bottom: 0; padding: 0 26px 0 0.6rem; width: 100%; cursor: pointer; overflow: hidden; } .linkular-select button.linkular-select-button span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select button.linkular-select-button svg { width: 26px; height: 38px; padding: 8px 2px; opacity: 1; position: absolute; right: 0; top: 0; box-sizing: border-box; } .linkular-select button.linkular-select-button:focus, .linkular-select button.linkular-select-button:active, .linkular-select button.linkular-select-button:hover { border: 1px solid #d1d1d1; } .linkular-select.disabled button.linkular-select-button { background: #f5f5f5; color: #4d4d4d; cursor: default; } .linkular-select.disabled button.linkular-select-button svg { fill: #4d4d4d; } .linkular-select ul.linkular-select-list { margin-top: -1px; display: none; position: absolute; list-style: none; background-color: white; width: 100%; max-height: 280px; overflow-y: auto; z-index: 5; top: 38px; border: 1px solid #d1d1d1; -webkit-border-radius: 4px; -moz-border-radius: 4px; -ms-border-radius: 4px; border-radius: 4px; -webkit-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); -moz-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); } .linkular-select ul.linkular-select-list li { padding: 0 .6rem; } .linkular-select ul.linkular-select-list li { color: black; margin: 0; width: 100%; display: block; font-size: 11px; font-weight: 600; line-height: 38px; height: 38px; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; background-color: transparent; border-bottom: 1px solid #d1d1d1; cursor: pointer; box-sizing: border-box; overflow: hidden; } .linkular-select ul.linkular-select-list li span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select ul.linkular-select-list li.selected { background: #1DE9B6; color: white; } .linkular-select ul.linkular-select-list li:last-child { border-bottom: none; } .linkular-select.opened ul.linkular-select-list { display: block; } .linkular-select.opened button.linkular-select-button { border: 1px solid #d1d1d1; } "],
                    providers: [
                        LINKULAR_SELECT_TRANSLATE_ACCESSOR
                    ],
                    host: {
                        '(document:click)': 'onClick($event)',
                    }
                },] },
    ];
    /** @nocollapse */
    LinkularSelectTranslateComponent.propDecorators = {
        "translationPrefix": [{ type: core.Input },],
    };
    return LinkularSelectTranslateComponent;
}(LinkularSelectComponent));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularColorpickerComponent = /** @class */ (function () {
    function LinkularColorpickerComponent() {
        this.label = "";
        this.model = "";
        this._color = "";
        this.colorChange = new core.EventEmitter();
    }
    Object.defineProperty(LinkularColorpickerComponent.prototype, "color", {
        get: /**
         * @return {?}
         */
        function () {
            return this._color;
        },
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._color = val;
            this.colorChange.emit(val);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LinkularColorpickerComponent.prototype.setValue = /**
     * @return {?}
     */
    function () {
        this.color = this.model;
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    LinkularColorpickerComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        for (var /** @type {?} */ propName in changes) {
            if (propName === 'color') {
                var /** @type {?} */ change = changes[propName];
                this.model = change.currentValue;
            }
        }
    };
    LinkularColorpickerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-colorpicker',
                    template: "<label translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <div class=\"form-group group-limited\"> <span class=\"input-group-addon\"> <div class=\"colors\" [style.background-color]=\"model\"></div> </span> <input [(colorPicker)]=\"model\" name=\"header-color\" [value]=\"model\" (colorPickerChange)=\"setValue()\" type=\"text\" /> </div> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    styles: [""]
                },] },
    ];
    /** @nocollapse */
    LinkularColorpickerComponent.propDecorators = {
        "label": [{ type: core.Input },],
        "errorMsg": [{ type: core.Input },],
        "info": [{ type: core.Input },],
        "colorChange": [{ type: core.Output },],
        "color": [{ type: core.Input },],
    };
    return LinkularColorpickerComponent;
}());

var __extends$4 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_DURATION_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularDurationComponent; }),
    multi: true
};
var LinkularDurationComponent = /** @class */ (function (_super) {
    __extends$4(LinkularDurationComponent, _super);
    function LinkularDurationComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.propagateChange = function () { };
        return _this;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularDurationComponent.prototype.writeValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.model = this.durationToString(val);
    };
    /**
     * @return {?}
     */
    LinkularDurationComponent.prototype.setValue = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ valueAsInt = this.durationToSeconds(this.model);
        var /** @type {?} */ valueAsString = this.durationToString(valueAsInt);
        if (valueAsString !== this.model) {
            this.model = valueAsString;
        }
        this.propagateChange(valueAsInt);
    };
    /**
     * @param {?} duration
     * @return {?}
     */
    LinkularDurationComponent.prototype.durationToString = /**
     * @param {?} duration
     * @return {?}
     */
    function (duration) {
        var /** @type {?} */ output = '';
        if (duration === 0) {
            return 0;
        }
        var /** @type {?} */ days = Math.floor(duration / 86400);
        output += (days) ? days + 'd ' : '';
        duration -= days * 86400;
        var /** @type {?} */ hours = Math.floor(duration / 3600) % 24;
        output += (hours) ? hours + 'h ' : '';
        duration -= hours * 3600;
        var /** @type {?} */ minutes = Math.floor(duration / 60) % 60;
        output += (minutes) ? minutes + 'm ' : '';
        duration -= minutes * 60;
        var /** @type {?} */ seconds = duration % 60;
        output += (seconds) ? seconds + 's ' : '';
        if (output && output.length > 1) {
            output = output.slice(0, -1);
        }
        return output;
    };
    /**
     * @param {?} duration
     * @return {?}
     */
    LinkularDurationComponent.prototype.durationToSeconds = /**
     * @param {?} duration
     * @return {?}
     */
    function (duration) {
        duration = duration.replace(/[^0-9dhmsDHMS ]/g, '');
        var /** @type {?} */ output = 0;
        var /** @type {?} */ durationArray = [];
        durationArray = duration.split(' ');
        output = durationArray.reduce(function (s, el) {
            var /** @type {?} */ elVal = 0;
            var /** @type {?} */ re = new RegExp(/[0-9]+[dhms]/, 'g');
            var /** @type {?} */ checkArray = el.match(re);
            if (checkArray === null && !isNaN(el)) {
                return s + parseInt(el);
            }
            elVal = checkArray.reduce(function (elS, item) {
                var /** @type {?} */ itemVal = 0;
                var /** @type {?} */ reEl = new RegExp(/[0-9]+|[dhms]/, 'g');
                var /** @type {?} */ value = item.match(reEl);
                switch (value[1]) {
                    case 'd':
                        itemVal = value[0] * 86400;
                        break;
                    case 'h':
                        itemVal = value[0] * 3600;
                        break;
                    case 'm':
                        itemVal = value[0] * 60;
                        break;
                    default:
                        itemVal = value[0];
                        break;
                }
                return elS + itemVal;
            }, 0);
            return s + elVal;
        }, 0);
        return output;
    };
    LinkularDurationComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-duration',
                    template: "<label translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <input class=\"u-full-width\" [(ngModel)]=\"model\" (blur)=\"setValue()\" [type]=\"type\" placeholder=\"E.g. 8h 30m\" /> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    providers: [
                        LINKULAR_DURATION_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularDurationComponent.propDecorators = {
        "errorMsg": [{ type: core.Input },],
    };
    return LinkularDurationComponent;
}(LinkularInputComponent));

var __extends$5 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_TIME_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularTimeComponent; }),
    multi: true
};
var LinkularTimeComponent = /** @class */ (function (_super) {
    __extends$5(LinkularTimeComponent, _super);
    function LinkularTimeComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.propagateChange = function () { };
        return _this;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularTimeComponent.prototype.writeValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.model = this.minutesToTimeString(val);
    };
    /**
     * @return {?}
     */
    LinkularTimeComponent.prototype.setValue = /**
     * @return {?}
     */
    function () {
        this.propagateChange(this.timeStringToMinutes(this.model));
    };
    /**
     * @param {?} duration
     * @return {?}
     */
    LinkularTimeComponent.prototype.minutesToTimeString = /**
     * @param {?} duration
     * @return {?}
     */
    function (duration) {
        var /** @type {?} */ output = '';
        if (duration === 0) {
            return '0';
        }
        else if (duration >= 1440) {
            return '24:00';
        }
        var /** @type {?} */ hours = Math.floor(duration / 60) % 24;
        output += hours;
        var /** @type {?} */ minutes = duration - hours * 60;
        output += ':';
        output += (minutes > 9) ? minutes : '0' + minutes;
        return output;
    };
    /**
     * @param {?} duration
     * @return {?}
     */
    LinkularTimeComponent.prototype.timeStringToMinutes = /**
     * @param {?} duration
     * @return {?}
     */
    function (duration) {
        var _this = this;
        var /** @type {?} */ output = 0;
        var /** @type {?} */ durationArray = [];
        durationArray = duration.split(':');
        if (durationArray.length === 2) {
            durationArray.forEach(function (x, i) {
                var /** @type {?} */ val = parseInt(x, 10);
                if (isNaN(val)) {
                    _this.model = '0';
                    return 0;
                }
                output += (i === 0) ? val * 60 : val;
            });
        }
        else {
            this.model = '0';
            return 0;
        }
        return output;
    };
    LinkularTimeComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-time',
                    template: "<label translate>{{label}}<span class=\"info\" *ngIf=\"info\" translate>{{info}}</span></label> <input class=\"u-full-width\" [(ngModel)]=\"model\" (blur)=\"setValue()\" [type]=\"type\" placeholder=\"E.g. 9:00\" />",
                    providers: [
                        LINKULAR_TIME_ACCESSOR
                    ]
                },] },
    ];
    return LinkularTimeComponent;
}(LinkularInputComponent));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */

var countryCodes = [{
        'name': 'United States/Canada',
        'dialCode': '1',
        'code': 'US'
    }, {
        'name': 'Afghanistan',
        'dialCode': '93',
        'code': 'AF'
    }, {
        'name': 'Albania',
        'dialCode': '355',
        'code': 'AL'
    }, {
        'name': 'Algeria',
        'dialCode': '213',
        'code': 'DZ'
    }, {
        'name': 'Andorra',
        'dialCode': '376',
        'code': 'AD'
    }, {
        'name': 'Angola',
        'dialCode': '244',
        'code': 'AO'
    }, {
        'name': 'Antarctica',
        'dialCode': '672',
        'code': 'AQ'
    }, {
        'name': 'Antigua and Barbuda',
        'dialCode': '1268',
        'code': 'AG'
    }, {
        'name': 'Argentina',
        'dialCode': '54',
        'code': 'AR'
    }, {
        'name': 'Armenia',
        'dialCode': '374',
        'code': 'AM'
    }, {
        'name': 'Aruba',
        'dialCode': '297',
        'code': 'AW'
    }, {
        'name': 'Australia',
        'dialCode': '61',
        'code': 'AU'
    }, {
        'name': 'Austria',
        'dialCode': '43',
        'code': 'AT'
    }, {
        'name': 'Azerbaijan',
        'dialCode': '994',
        'code': 'AZ'
    }, {
        'name': 'Bahrain',
        'dialCode': '973',
        'code': 'BH'
    }, {
        'name': 'Bangladesh',
        'dialCode': '880',
        'code': 'BD'
    }, {
        'name': 'Belarus',
        'dialCode': '375',
        'code': 'BY'
    }, {
        'name': 'Belgium',
        'dialCode': '32',
        'code': 'BE'
    }, {
        'name': 'Belize',
        'dialCode': '501',
        'code': 'BZ'
    }, {
        'name': 'Benin',
        'dialCode': '229',
        'code': 'BJ'
    }, {
        'name': 'Bhutan',
        'dialCode': '975',
        'code': 'BT'
    }, {
        'name': 'Bolivia, Plurinational State of',
        'dialCode': '591',
        'code': 'BO'
    }, {
        'name': 'Bosnia and Herzegovina',
        'dialCode': '387',
        'code': 'BA'
    }, {
        'name': 'Botswana',
        'dialCode': '267',
        'code': 'BW'
    }, {
        'name': 'Brazil',
        'dialCode': '55',
        'code': 'BR'
    }, {
        'name': 'British Indian Ocean Territory',
        'dialCode': '246',
        'code': 'IO'
    }, {
        'name': 'Brunei Darussalam',
        'dialCode': '673',
        'code': 'BN'
    }, {
        'name': 'Bulgaria',
        'dialCode': '359',
        'code': 'BG'
    }, {
        'name': 'Burkina Faso',
        'dialCode': '226',
        'code': 'BF'
    }, {
        'name': 'Burundi',
        'dialCode': '257',
        'code': 'BI'
    }, {
        'name': 'Cambodia',
        'dialCode': '855',
        'code': 'KH'
    }, {
        'name': 'Cameroon',
        'dialCode': '237',
        'code': 'CM'
    }, {
        'name': 'Cape Verde',
        'dialCode': '238',
        'code': 'CV'
    }, {
        'name': 'Cayman Islands',
        'dialCode': ' 345',
        'code': 'KY'
    }, {
        'name': 'Central African Republic',
        'dialCode': '236',
        'code': 'CF'
    }, {
        'name': 'Chad',
        'dialCode': '235',
        'code': 'TD'
    }, {
        'name': 'Chile',
        'dialCode': '56',
        'code': 'CL'
    }, {
        'name': 'China',
        'dialCode': '86',
        'code': 'CN'
    }, {
        'name': 'Colombia',
        'dialCode': '57',
        'code': 'CO'
    }, {
        'name': 'Comoros',
        'dialCode': '269',
        'code': 'KM'
    }, {
        'name': 'Congo',
        'dialCode': '242',
        'code': 'CG'
    }, {
        'name': 'Congo, The Democratic Republic of the Congo',
        'dialCode': '243',
        'code': 'CD'
    }, {
        'name': 'Cook Islands',
        'dialCode': '682',
        'code': 'CK'
    }, {
        'name': 'Costa Rica',
        'dialCode': '506',
        'code': 'CR'
    }, {
        'name': 'Cote d\'Ivoire',
        'dialCode': '225',
        'code': 'CI'
    }, {
        'name': 'Croatia',
        'dialCode': '385',
        'code': 'HR'
    }, {
        'name': 'Cuba',
        'dialCode': '53',
        'code': 'CU'
    }, {
        'name': 'Cyprus',
        'dialCode': '357',
        'code': 'CY'
    }, {
        'name': 'Czech Republic',
        'dialCode': '420',
        'code': 'CZ'
    }, {
        'name': 'Denmark',
        'dialCode': '45',
        'code': 'DK'
    }, {
        'name': 'Djibouti',
        'dialCode': '253',
        'code': 'DJ'
    }, {
        'name': 'Ecuador',
        'dialCode': '593',
        'code': 'EC'
    }, {
        'name': 'Egypt',
        'dialCode': '20',
        'code': 'EG'
    }, {
        'name': 'El Salvador',
        'dialCode': '503',
        'code': 'SV'
    }, {
        'name': 'Equatorial Guinea',
        'dialCode': '240',
        'code': 'GQ'
    }, {
        'name': 'Eritrea',
        'dialCode': '291',
        'code': 'ER'
    }, {
        'name': 'Estonia',
        'dialCode': '372',
        'code': 'EE'
    }, {
        'name': 'Ethiopia',
        'dialCode': '251',
        'code': 'ET'
    }, {
        'name': 'Falkland Islands (Malvinas)',
        'dialCode': '500',
        'code': 'FK'
    }, {
        'name': 'Faroe Islands',
        'dialCode': '298',
        'code': 'FO'
    }, {
        'name': 'Fiji',
        'dialCode': '679',
        'code': 'FJ'
    }, {
        'name': 'Finland',
        'dialCode': '358',
        'code': 'FI'
    }, {
        'name': 'France',
        'dialCode': '33',
        'code': 'FR'
    }, {
        'name': 'French Guiana',
        'dialCode': '594',
        'code': 'GF'
    }, {
        'name': 'French Polynesia',
        'dialCode': '689',
        'code': 'PF'
    }, {
        'name': 'Gabon',
        'dialCode': '241',
        'code': 'GA'
    }, {
        'name': 'Gambia',
        'dialCode': '220',
        'code': 'GM'
    }, {
        'name': 'Georgia',
        'dialCode': '995',
        'code': 'GE'
    }, {
        'name': 'Germany',
        'dialCode': '49',
        'code': 'DE'
    }, {
        'name': 'Ghana',
        'dialCode': '233',
        'code': 'GH'
    }, {
        'name': 'Gibraltar',
        'dialCode': '350',
        'code': 'GI'
    }, {
        'name': 'Greece',
        'dialCode': '30',
        'code': 'GR'
    }, {
        'name': 'Greenland',
        'dialCode': '299',
        'code': 'GL'
    }, {
        'name': 'Guatemala',
        'dialCode': '502',
        'code': 'GT'
    }, {
        'name': 'Guinea',
        'dialCode': '224',
        'code': 'GN'
    }, {
        'name': 'Guinea-Bissau',
        'dialCode': '245',
        'code': 'GW'
    }, {
        'name': 'Haiti',
        'dialCode': '509',
        'code': 'HT'
    }, {
        'name': 'Holy See (Vatican City State)',
        'dialCode': '379',
        'code': 'VA'
    }, {
        'name': 'Honduras',
        'dialCode': '504',
        'code': 'HN'
    }, {
        'name': 'Hong Kong',
        'dialCode': '852',
        'code': 'HK'
    }, {
        'name': 'Hungary',
        'dialCode': '36',
        'code': 'HU'
    }, {
        'name': 'Iceland',
        'dialCode': '354',
        'code': 'IS'
    }, {
        'name': 'India',
        'dialCode': '91',
        'code': 'IN'
    }, {
        'name': 'Indonesia',
        'dialCode': '62',
        'code': 'ID'
    }, {
        'name': 'Iran, Islamic Republic of Persian Gulf',
        'dialCode': '98',
        'code': 'IR'
    }, {
        'name': 'Iraq',
        'dialCode': '964',
        'code': 'IQ'
    }, {
        'name': 'Ireland',
        'dialCode': '353',
        'code': 'IE'
    }, {
        'name': 'Israel',
        'dialCode': '972',
        'code': 'IL'
    }, {
        'name': 'Italy',
        'dialCode': '39',
        'code': 'IT'
    }, {
        'name': 'Japan',
        'dialCode': '81',
        'code': 'JP'
    }, {
        'name': 'Jordan',
        'dialCode': '962',
        'code': 'JO'
    }, {
        'name': 'Kazakhstan',
        'dialCode': '7 7',
        'code': 'KZ'
    }, {
        'name': 'Kenya',
        'dialCode': '254',
        'code': 'KE'
    }, {
        'name': 'Kiribati',
        'dialCode': '686',
        'code': 'KI'
    }, {
        'name': 'Korea, Democratic People\'s Republic of Korea',
        'dialCode': '850',
        'code': 'KP'
    }, {
        'name': 'Korea, Republic of South Korea',
        'dialCode': '82',
        'code': 'KR'
    }, {
        'name': 'Kuwait',
        'dialCode': '965',
        'code': 'KW'
    }, {
        'name': 'Kyrgyzstan',
        'dialCode': '996',
        'code': 'KG'
    }, {
        'name': 'Laos',
        'dialCode': '856',
        'code': 'LA'
    }, {
        'name': 'Latvia',
        'dialCode': '371',
        'code': 'LV'
    }, {
        'name': 'Lebanon',
        'dialCode': '961',
        'code': 'LB'
    }, {
        'name': 'Lesotho',
        'dialCode': '266',
        'code': 'LS'
    }, {
        'name': 'Liberia',
        'dialCode': '231',
        'code': 'LR'
    }, {
        'name': 'Libyan Arab Jamahiriya',
        'dialCode': '218',
        'code': 'LY'
    }, {
        'name': 'Liechtenstein',
        'dialCode': '423',
        'code': 'LI'
    }, {
        'name': 'Lithuania',
        'dialCode': '370',
        'code': 'LT'
    }, {
        'name': 'Luxembourg',
        'dialCode': '352',
        'code': 'LU'
    }, {
        'name': 'Macao',
        'dialCode': '853',
        'code': 'MO'
    }, {
        'name': 'Macedonia',
        'dialCode': '389',
        'code': 'MK'
    }, {
        'name': 'Madagascar',
        'dialCode': '261',
        'code': 'MG'
    }, {
        'name': 'Malawi',
        'dialCode': '265',
        'code': 'MW'
    }, {
        'name': 'Malaysia',
        'dialCode': '60',
        'code': 'MY'
    }, {
        'name': 'Maldives',
        'dialCode': '960',
        'code': 'MV'
    }, {
        'name': 'Mali',
        'dialCode': '223',
        'code': 'ML'
    }, {
        'name': 'Malta',
        'dialCode': '356',
        'code': 'MT'
    }, {
        'name': 'Marshall Islands',
        'dialCode': '692',
        'code': 'MH'
    }, {
        'name': 'Martinique',
        'dialCode': '596',
        'code': 'MQ'
    }, {
        'name': 'Mauritania',
        'dialCode': '222',
        'code': 'MR'
    }, {
        'name': 'Mauritius',
        'dialCode': '230',
        'code': 'MU'
    }, {
        'name': 'Mexico',
        'dialCode': '52',
        'code': 'MX'
    }, {
        'name': 'Micronesia, Federated States of Micronesia',
        'dialCode': '691',
        'code': 'FM'
    }, {
        'name': 'Moldova',
        'dialCode': '373',
        'code': 'MD'
    }, {
        'name': 'Monaco',
        'dialCode': '377',
        'code': 'MC'
    }, {
        'name': 'Mongolia',
        'dialCode': '976',
        'code': 'MN'
    }, {
        'name': 'Montenegro',
        'dialCode': '382',
        'code': 'ME'
    }, {
        'name': 'Montserrat',
        'dialCode': '1664',
        'code': 'MS'
    }, {
        'name': 'Morocco',
        'dialCode': '212',
        'code': 'MA'
    }, {
        'name': 'Mozambique',
        'dialCode': '258',
        'code': 'MZ'
    }, {
        'name': 'Myanmar',
        'dialCode': '95',
        'code': 'MM'
    }, {
        'name': 'Namibia',
        'dialCode': '264',
        'code': 'NA'
    }, {
        'name': 'Nauru',
        'dialCode': '674',
        'code': 'NR'
    }, {
        'name': 'Nepal',
        'dialCode': '977',
        'code': 'NP'
    }, {
        'name': 'Netherlands',
        'dialCode': '31',
        'code': 'NL'
    }, {
        'name': 'Netherlands Antilles',
        'dialCode': '599',
        'code': 'AN'
    }, {
        'name': 'New Caledonia',
        'dialCode': '687',
        'code': 'NC'
    }, {
        'name': 'New Zealand',
        'dialCode': '64',
        'code': 'NZ'
    }, {
        'name': 'Nicaragua',
        'dialCode': '505',
        'code': 'NI'
    }, {
        'name': 'Niger',
        'dialCode': '227',
        'code': 'NE'
    }, {
        'name': 'Nigeria',
        'dialCode': '234',
        'code': 'NG'
    }, {
        'name': 'Niue',
        'dialCode': '683',
        'code': 'NU'
    }, {
        'name': 'Norway',
        'dialCode': '47',
        'code': 'NO'
    }, {
        'name': 'Oman',
        'dialCode': '968',
        'code': 'OM'
    }, {
        'name': 'Pakistan',
        'dialCode': '92',
        'code': 'PK'
    }, {
        'name': 'Palau',
        'dialCode': '680',
        'code': 'PW'
    }, {
        'name': 'Palestinian Territory, Occupied',
        'dialCode': '970',
        'code': 'PS'
    }, {
        'name': 'Panama',
        'dialCode': '507',
        'code': 'PA'
    }, {
        'name': 'Papua New Guinea',
        'dialCode': '675',
        'code': 'PG'
    }, {
        'name': 'Paraguay',
        'dialCode': '595',
        'code': 'PY'
    }, {
        'name': 'Peru',
        'dialCode': '51',
        'code': 'PE'
    }, {
        'name': 'Philippines',
        'dialCode': '63',
        'code': 'PH'
    }, {
        'name': 'Pitcairn',
        'dialCode': '872',
        'code': 'PN'
    }, {
        'name': 'Poland',
        'dialCode': '48',
        'code': 'PL'
    }, {
        'name': 'Portugal',
        'dialCode': '351',
        'code': 'PT'
    }, {
        'name': 'Qatar',
        'dialCode': '974',
        'code': 'QA'
    }, {
        'name': 'Romania',
        'dialCode': '40',
        'code': 'RO'
    }, {
        'name': 'Russia',
        'dialCode': '7',
        'code': 'RU'
    }, {
        'name': 'Rwanda',
        'dialCode': '250',
        'code': 'RW'
    }, {
        'name': 'Reunion',
        'dialCode': '262',
        'code': 'RE'
    }, {
        'name': 'Saint Helena, Ascension and Tristan Da Cunha',
        'dialCode': '290',
        'code': 'SH'
    }, {
        'name': 'Saint Martin',
        'dialCode': '590',
        'code': 'MF'
    }, {
        'name': 'Saint Pierre and Miquelon',
        'dialCode': '508',
        'code': 'PM'
    }, {
        'name': 'Samoa',
        'dialCode': '685',
        'code': 'WS'
    }, {
        'name': 'San Marino',
        'dialCode': '378',
        'code': 'SM'
    }, {
        'name': 'Sao Tome and Principe',
        'dialCode': '239',
        'code': 'ST'
    }, {
        'name': 'Saudi Arabia',
        'dialCode': '966',
        'code': 'SA'
    }, {
        'name': 'Senegal',
        'dialCode': '221',
        'code': 'SN'
    }, {
        'name': 'Serbia',
        'dialCode': '381',
        'code': 'RS'
    }, {
        'name': 'Seychelles',
        'dialCode': '248',
        'code': 'SC'
    }, {
        'name': 'Sierra Leone',
        'dialCode': '232',
        'code': 'SL'
    }, {
        'name': 'Singapore',
        'dialCode': '65',
        'code': 'SG'
    }, {
        'name': 'Slovakia',
        'dialCode': '421',
        'code': 'SK'
    }, {
        'name': 'Slovenia',
        'dialCode': '386',
        'code': 'SI'
    }, {
        'name': 'Solomon Islands',
        'dialCode': '677',
        'code': 'SB'
    }, {
        'name': 'Somalia',
        'dialCode': '252',
        'code': 'SO'
    }, {
        'name': 'South Africa',
        'dialCode': '27',
        'code': 'ZA'
    }, {
        'name': 'Spain',
        'dialCode': '34',
        'code': 'ES'
    }, {
        'name': 'Sri Lanka',
        'dialCode': '94',
        'code': 'LK'
    }, {
        'name': 'Sudan',
        'dialCode': '249',
        'code': 'SD'
    }, {
        'name': 'Suriname',
        'dialCode': '597',
        'code': 'SR'
    }, {
        'name': 'Swaziland',
        'dialCode': '268',
        'code': 'SZ'
    }, {
        'name': 'Sweden',
        'dialCode': '46',
        'code': 'SE'
    }, {
        'name': 'Switzerland',
        'dialCode': '41',
        'code': 'CH'
    }, {
        'name': 'Syrian Arab Republic',
        'dialCode': '963',
        'code': 'SY'
    }, {
        'name': 'Taiwan',
        'dialCode': '886',
        'code': 'TW'
    }, {
        'name': 'Tajikistan',
        'dialCode': '992',
        'code': 'TJ'
    }, {
        'name': 'Tanzania, United Republic of Tanzania',
        'dialCode': '255',
        'code': 'TZ'
    }, {
        'name': 'Thailand',
        'dialCode': '66',
        'code': 'TH'
    }, {
        'name': 'Timor-Leste',
        'dialCode': '670',
        'code': 'TL'
    }, {
        'name': 'Togo',
        'dialCode': '228',
        'code': 'TG'
    }, {
        'name': 'Tokelau',
        'dialCode': '690',
        'code': 'TK'
    }, {
        'name': 'Tonga',
        'dialCode': '676',
        'code': 'TO'
    }, {
        'name': 'Tunisia',
        'dialCode': '216',
        'code': 'TN'
    }, {
        'name': 'Turkey',
        'dialCode': '90',
        'code': 'TR'
    }, {
        'name': 'Turkmenistan',
        'dialCode': '993',
        'code': 'TM'
    }, {
        'name': 'Tuvalu',
        'dialCode': '688',
        'code': 'TV'
    }, {
        'name': 'Uganda',
        'dialCode': '256',
        'code': 'UG'
    }, {
        'name': 'Ukraine',
        'dialCode': '380',
        'code': 'UA'
    }, {
        'name': 'United Arab Emirates',
        'dialCode': '971',
        'code': 'AE'
    }, {
        'name': 'United Kingdom',
        'dialCode': '44',
        'code': 'GB'
    }, {
        'name': 'Uruguay',
        'dialCode': '598',
        'code': 'UY'
    }, {
        'name': 'Uzbekistan',
        'dialCode': '998',
        'code': 'UZ'
    }, {
        'name': 'Vanuatu',
        'dialCode': '678',
        'code': 'VU'
    }, {
        'name': 'Venezuela, Bolivarian Republic of Venezuela',
        'dialCode': '58',
        'code': 'VE'
    }, {
        'name': 'Vietnam',
        'dialCode': '84',
        'code': 'VN'
    }, {
        'name': 'Wallis and Futuna',
        'dialCode': '681',
        'code': 'WF'
    }, {
        'name': 'Yemen',
        'dialCode': '967',
        'code': 'YE'
    }, {
        'name': 'Zambia',
        'dialCode': '260',
        'code': 'ZM'
    }, {
        'name': 'Zimbabwe',
        'dialCode': '263',
        'code': 'ZW'
    }];

var __extends$6 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_COUNTRYCODE_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularCountryCodeComponent; }),
    multi: true
};
var LinkularCountryCodeComponent = /** @class */ (function (_super) {
    __extends$6(LinkularCountryCodeComponent, _super);
    function LinkularCountryCodeComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.list = countryCodes;
        _this.saveBy = 'dialCode';
        _this.all = true;
        return _this;
    }
    /**
     * @param {?=} codes
     * @return {?}
     */
    LinkularCountryCodeComponent.prototype.toggleList = /**
     * @param {?=} codes
     * @return {?}
     */
    function (codes) {
        if (codes && codes.length > 0) {
            var /** @type {?} */ tempCountryCodes_1 = countryCodes.slice();
            var /** @type {?} */ tempList = codes.map(function (code) {
                return tempCountryCodes_1.find(function (x) { return x.dialCode === code.toString(); });
            });
            this.list = tempList;
        }
        else {
            this.list = countryCodes;
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    LinkularCountryCodeComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        for (var /** @type {?} */ propName in changes) {
            if (propName === 'codes') {
                var /** @type {?} */ change = changes[propName];
                this.toggleList(change.currentValue);
            }
            else if (propName === 'full') {
                var /** @type {?} */ change = changes[propName];
                if (change.currentValue) {
                    this.toggleList();
                }
            }
        }
    };
    LinkularCountryCodeComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-country-code',
                    template: "<label translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <div class=\"linkular-select\" [class.opened]=\"opened\" [class.disabled]=\"disable\"> <button type=\"button\" class=\"linkular-select-button\" (click)=\"toggle()\"> <span *ngIf=\"fullValue\">{{fullValue.name}} <span class=\"dial-code\">(+{{fullValue.dialCode}})</span></span> <svg *ngIf=\"(!fullValue && list.length > 0) || (fullValue && list.length > 1)\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" viewBox=\"0 0 200 200\"> <path *ngIf=\"icon === 'caret-up'\" d=\"M43.59,122.3a4.1,4.1,0,0,0,5.8,0l51-51.1,51.1,51.1a4.1,4.1,0,1,0,5.8-5.8l-53.9-53.9a4,4,0,0,0-2.9-1.2,4.18,4.18,0,0,0-2.9,1.2l-53.9,53.9A4,4,0,0,0,43.59,122.3Z\" /> <path *ngIf=\"icon === 'caret-down'\" d=\"M157.3,78.6a4.1,4.1,0,0,0-5.8,0l-51,51.1L49.4,78.6a4.1,4.1,0,1,0-5.8,5.8l53.9,53.9a4,4,0,0,0,2.9,1.2,4.18,4.18,0,0,0,2.9-1.2l53.9-53.9A4,4,0,0,0,157.3,78.6Z\" /> </svg> </button> <ul class=\"linkular-select-list\" *ngIf=\"(!fullValue && list.length > 0) || (fullValue && list.length > 1)\"> <li class=\"select-option\" [class.selected]=\"fullValue && fullValue.dialCode === el.dialCode\" *ngFor=\"let el of list\" (click)=\"select(el)\"> {{el.name}} <span class=\"dial-code\">(+{{el.dialCode}})</span> </li> </ul> </div> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    styles: [".linkular-select { position: relative; display: block; width: 100%; margin-bottom: 15px; height: 38px; } .linkular-select button.linkular-select-button { background: white; color: black; text-align: left; margin-bottom: 0; padding: 0 26px 0 0.6rem; width: 100%; cursor: pointer; overflow: hidden; } .linkular-select button.linkular-select-button span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select button.linkular-select-button svg { width: 26px; height: 38px; padding: 8px 2px; opacity: 1; position: absolute; right: 0; top: 0; box-sizing: border-box; } .linkular-select button.linkular-select-button:focus, .linkular-select button.linkular-select-button:active, .linkular-select button.linkular-select-button:hover { border: 1px solid #d1d1d1; } .linkular-select.disabled button.linkular-select-button { background: #f5f5f5; color: #4d4d4d; cursor: default; } .linkular-select.disabled button.linkular-select-button svg { fill: #4d4d4d; } .linkular-select ul.linkular-select-list { margin-top: -1px; display: none; position: absolute; list-style: none; background-color: white; width: 100%; max-height: 280px; overflow-y: auto; z-index: 5; top: 38px; border: 1px solid #d1d1d1; -webkit-border-radius: 4px; -moz-border-radius: 4px; -ms-border-radius: 4px; border-radius: 4px; -webkit-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); -moz-box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.1); } .linkular-select ul.linkular-select-list li { padding: 0 .6rem; } .linkular-select ul.linkular-select-list li { color: black; margin: 0; width: 100%; display: block; font-size: 11px; font-weight: 600; line-height: 38px; height: 38px; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; background-color: transparent; border-bottom: 1px solid #d1d1d1; cursor: pointer; box-sizing: border-box; overflow: hidden; } .linkular-select ul.linkular-select-list li span { display: block; width: 100%; letter-spacing: 0; text-transform: none; text-decoration: none; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; } .linkular-select ul.linkular-select-list li.selected { background: #1DE9B6; color: white; } .linkular-select ul.linkular-select-list li:last-child { border-bottom: none; } .linkular-select.opened ul.linkular-select-list { display: block; } .linkular-select.opened button.linkular-select-button { border: 1px solid #d1d1d1; } ",
                        ""],
                    providers: [
                        LINKULAR_COUNTRYCODE_VALUE_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularCountryCodeComponent.propDecorators = {
        "saveBy": [{ type: core.Input },],
        "codes": [{ type: core.Input },],
        "full": [{ type: core.Input },],
        "all": [{ type: core.Input },],
    };
    return LinkularCountryCodeComponent;
}(LinkularSelectComponent));

var __extends$7 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_PHONE_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularPhoneNumberComponent; }),
    multi: true
};
var LinkularPhoneNumberComponent = /** @class */ (function (_super) {
    __extends$7(LinkularPhoneNumberComponent, _super);
    function LinkularPhoneNumberComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.dialCode = '';
        return _this;
    }
    LinkularPhoneNumberComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-phone-number',
                    template: "<label translate>{{label}}<span *ngIf=\"info\" translate>{{info}}</span></label> <div class=\"form-group\"> <span class=\"input-group-addon dial-code\">+{{dialCode}}</span> <input class=\"u-full-width\" [(ngModel)]=\"model\" (ngModelChange)=\"setValue($event)\" [type]=\"type\" [attr.disabled]=\"(disable) ? true : null\" /> </div> <p class=\"errorMsg\" *ngIf=\"errorMsg\" translate>{{errorMsg}}</p> ",
                    styles: [".form-group .input-group-addon.dial-code { background: #d1d1d1; padding: 6px 10px; -webkit-border-radius: 4px 0 0 4px; -moz-border-radius: 4px 0 0 4px; -ms-border-radius: 4px 0 0 4px; border-radius: 4px 0 0 4px; color: rgba(0, 0, 0, 0.8); } .form-group .input-group-addon.dial-code + input { -webkit-border-radius: 0 4px 4px 0; -moz-border-radius: 0 4px 4px 0; -ms-border-radius: 0 4px 4px 0; border-radius: 0 4px 4px 0; } "],
                    providers: [
                        LINKULAR_PHONE_VALUE_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularPhoneNumberComponent.propDecorators = {
        "dialCode": [{ type: core.Input },],
    };
    return LinkularPhoneNumberComponent;
}(LinkularInputComponent));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_SWITCH_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularSwitchComponent; }),
    multi: true
};
var LinkularSwitchComponent = /** @class */ (function () {
    function LinkularSwitchComponent() {
        this.propagateChange = function () { };
        this.label = '';
        this.textON = '';
        this.textOFF = '';
        this.disable = false;
        this.callback = new core.EventEmitter();
        this.model = '';
        this._value = '';
    }
    Object.defineProperty(LinkularSwitchComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () {
            return this._value;
        },
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            if (this._value !== val) {
                this._value = val;
                this.propagateChange(val);
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularSwitchComponent.prototype.writeValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        if (val) {
            this._value = val;
        }
    };
    /**
     * @return {?}
     */
    LinkularSwitchComponent.prototype.toggle = /**
     * @return {?}
     */
    function () {
        if (!this.disable) {
            this.value = !this._value;
            this.callback.emit();
        }
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    LinkularSwitchComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        if (!this.disable && isDisabled !== null) {
            this.disable = isDisabled;
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularSwitchComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularSwitchComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    LinkularSwitchComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-switch',
                    template: "<span class=\"switch\" [class.checked]=\"_value\" [class.disabled]=\"disable\" (click)=\"toggle()\"><small></small></span> <label *ngIf=\"label\" (click)=\"toggle()\" translate>{{label}}</label>",
                    styles: [":host { margin-bottom: 1.5rem; display: block; width: 100%; } :host::before, :host::after { content: \" \"; display: table; clear: both; } .switch { background: #FF8A80; position: relative; display: block; box-sizing: content-box; overflow: visible; padding: 0; margin: 0; width: 70px; height: 32px; float: left; cursor: pointer; -moz-transition: 0.3s ease-out all; -o-transition: 0.3s ease-out all; -webkit-transition: 0.3s ease-out all; transition: 0.3s ease-out all; -webkit-border-radius: 16px; -moz-border-radius: 16px; -ms-border-radius: 16px; border-radius: 16px; } .switch small { position: absolute; top: 5px; left: 5px; width: 35px; height: 22px; background: white; -webkit-border-radius: 11px; -moz-border-radius: 11px; -ms-border-radius: 11px; border-radius: 11px; -moz-transition: 0.3s ease-out all; -o-transition: 0.3s ease-out all; -webkit-transition: 0.3s ease-out all; transition: 0.3s ease-out all; } .switch.checked { background: #1DE9B6; } .switch.checked small { left: 30px; } .switch.disabled { opacity: .4; cursor: not-allowed; } label { line-height: 32px; display: block; float: left; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; margin: 0 0 0 6px; max-width: calc(100% - 76px); } "],
                    providers: [
                        LINKULAR_SWITCH_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularSwitchComponent.propDecorators = {
        "label": [{ type: core.Input },],
        "textON": [{ type: core.Input },],
        "textOFF": [{ type: core.Input },],
        "disable": [{ type: core.Input },],
        "callback": [{ type: core.Output },],
    };
    return LinkularSwitchComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularErrorDirective = /** @class */ (function () {
    function LinkularErrorDirective(_fg, _el, render) {
        this._fg = _fg;
        this._el = _el;
        this.render = render;
        this.hasView = false;
        render.setStyle(this._el.nativeElement, 'display', 'none');
    }
    /**
     * @return {?}
     */
    LinkularErrorDirective.prototype.setVisible = /**
     * @return {?}
     */
    function () {
        if (this.control.invalid && (this.control.dirty || this.hasSubmitted)) {
            this.render.removeStyle(this._el.nativeElement, 'display');
        }
        else {
            this.render.setStyle(this._el.nativeElement, 'display', 'none');
        }
    };
    /**
     * @param {?} error
     * @return {?}
     */
    LinkularErrorDirective.prototype.match = /**
     * @param {?} error
     * @return {?}
     */
    function (error) {
        if (this.control && this.control.errors) {
            if (Object.keys(this.control.errors).indexOf(error) > -1) {
                return true;
            }
        }
        return false;
    };
    Object.defineProperty(LinkularErrorDirective.prototype, "form", {
        get: /**
         * @return {?}
         */
        function () {
            return this._fg ? this._fg.control : null;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LinkularErrorDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.control = this.form.get(this.linkularError);
        this.setVisible();
        var /** @type {?} */ formSubmit$ = (/** @type {?} */ (this._fg.formDirective)).ngSubmit.pipe(operators.map(function () { return _this.hasSubmitted = true; }));
        this.controlValue$ = rxjs.merge(this.control.valueChanges, formSubmit$);
        this.controlSubscription = this.controlValue$.subscribe(function () { return _this.setVisible(); });
    };
    /**
     * @return {?}
     */
    LinkularErrorDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.controlSubscription.unsubscribe();
    };
    LinkularErrorDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[linkularError]'
                },] },
    ];
    /** @nocollapse */
    LinkularErrorDirective.ctorParameters = function () { return [
        { type: forms.ControlContainer, },
        { type: core.ElementRef, },
        { type: core.Renderer2, },
    ]; };
    LinkularErrorDirective.propDecorators = {
        "linkularError": [{ type: core.Input },],
    };
    return LinkularErrorDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularErrorMsgDirective = /** @class */ (function () {
    function LinkularErrorMsgDirective(errorMsgElement, templateRef, viewContainer) {
        this.errorMsgElement = errorMsgElement;
        this.templateRef = templateRef;
        this.viewContainer = viewContainer;
        this.hasView = false;
    }
    Object.defineProperty(LinkularErrorMsgDirective.prototype, "linkularErrorMsg", {
        set: /**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            this.type = type;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LinkularErrorMsgDirective.prototype.setVisible = /**
     * @return {?}
     */
    function () {
        if (this.errorMsgElement.match(this.type)) {
            if (!this.hasView) {
                this.viewContainer.createEmbeddedView(this.templateRef);
                this.hasView = true;
            }
        }
        else {
            if (this.hasView) {
                this.viewContainer.clear();
                this.hasView = false;
            }
        }
    };
    /**
     * @return {?}
     */
    LinkularErrorMsgDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.errorMsgElement.controlValue$.subscribe(function () { return _this.setVisible(); });
    };
    LinkularErrorMsgDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[linkularErrorMsg]'
                },] },
    ];
    /** @nocollapse */
    LinkularErrorMsgDirective.ctorParameters = function () { return [
        { type: LinkularErrorDirective, },
        { type: core.TemplateRef, },
        { type: core.ViewContainerRef, },
    ]; };
    LinkularErrorMsgDirective.propDecorators = {
        "linkularErrorMsg": [{ type: core.Input },],
    };
    return LinkularErrorMsgDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularFormModule = /** @class */ (function () {
    function LinkularFormModule() {
    }
    LinkularFormModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        core$1.TranslateModule,
                        ngxColorPicker.ColorPickerModule
                    ],
                    declarations: [
                        LinkularInputComponent,
                        LinkularInputAddonComponent,
                        LinkularCheckboxComponent,
                        LinkularTextareaComponent,
                        SMSCounterComponent,
                        LinkularSelectComponent,
                        LinkularSelectLanguageComponent,
                        LinkularSelectLanguage2Component,
                        LinkularSelectTranslateComponent,
                        LinkularColorpickerComponent,
                        LinkularDurationComponent,
                        LinkularTimeComponent,
                        LinkularCountryCodeComponent,
                        LinkularPhoneNumberComponent,
                        LinkularSwitchComponent
                    ],
                    exports: [
                        LinkularInputComponent,
                        LinkularInputAddonComponent,
                        LinkularCheckboxComponent,
                        LinkularTextareaComponent,
                        LinkularSelectComponent,
                        LinkularSelectLanguageComponent,
                        LinkularSelectLanguage2Component,
                        LinkularSelectTranslateComponent,
                        LinkularColorpickerComponent,
                        LinkularDurationComponent,
                        LinkularTimeComponent,
                        LinkularCountryCodeComponent,
                        LinkularPhoneNumberComponent,
                        LinkularSwitchComponent
                    ]
                },] },
    ];
    return LinkularFormModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularInfiniteDirective = /** @class */ (function () {
    function LinkularInfiniteDirective(el) {
        var _this = this;
        this.el = el;
        this.isVisible = true;
        this.scrollPercent = 95;
        this.isUserScrollingDown = function (positions) { return positions[0].sT < positions[1].sT; };
        this.isScrollExpectedPercent = function (position) { return ((position.sT + position.cH) / position.sH) > (_this.scrollPercent / 100); };
    }
    /**
     * @return {?}
     */
    LinkularInfiniteDirective.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        var /** @type {?} */ source = rxjs.fromEvent(this.el.nativeElement, 'scroll');
        var /** @type {?} */ scrollable = source.pipe(operators.map(function (e) {
            return ({
                sH: e.target.scrollHeight,
                sT: e.target.scrollTop,
                cH: e.target.clientHeight
            });
        }), operators.pairwise(), operators.filter(function (positions) { return !_this.done && _this.isUserScrollingDown(positions) && _this.isScrollExpectedPercent(positions[1]); }));
        scrollable.subscribe(function (val) { return _this.refresh(); });
    };
    LinkularInfiniteDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[linkularInfinite]'
                },] },
    ];
    /** @nocollapse */
    LinkularInfiniteDirective.ctorParameters = function () { return [
        { type: core.ElementRef, },
    ]; };
    LinkularInfiniteDirective.propDecorators = {
        "refresh": [{ type: core.Input },],
        "done": [{ type: core.Input },],
    };
    return LinkularInfiniteDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularInfiniteModule = /** @class */ (function () {
    function LinkularInfiniteModule() {
    }
    LinkularInfiniteModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule
                    ],
                    declarations: [
                        LinkularInfiniteDirective
                    ],
                    exports: [
                        LinkularInfiniteDirective
                    ]
                },] },
    ];
    return LinkularInfiniteModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LINKULAR_COLLAPSE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LinkularCollapseComponent; }),
    multi: true
};
var LinkularCollapseComponent = /** @class */ (function () {
    function LinkularCollapseComponent() {
        this.propagateChange = function () { };
        this.opened = true;
        this.content = true;
        this.error = false;
        this.success = false;
        this.changed = false;
        this.delete = new core.EventEmitter();
        this.showDelete = false;
        this.footer = new core.EventEmitter();
        this.showFooter = false;
        this.edit = false;
        this.model = '';
        this.test = '';
    }
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularCollapseComponent.prototype.writeValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.model = val || '';
    };
    /**
     * @param {?} val
     * @return {?}
     */
    LinkularCollapseComponent.prototype.setValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.propagateChange(val);
    };
    /**
     * @return {?}
     */
    LinkularCollapseComponent.prototype.toggle = /**
     * @return {?}
     */
    function () {
        this.opened = !this.opened;
    };
    /**
     * @return {?}
     */
    LinkularCollapseComponent.prototype.toggleEditTitle = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.edit = !this.edit;
        if (this.edit) {
            setTimeout(function () {
                _this.el.nativeElement.focus();
            }, 100);
        }
    };
    /**
     * @return {?}
     */
    LinkularCollapseComponent.prototype.deleteCallback = /**
     * @return {?}
     */
    function () {
        this.delete.emit(null);
    };
    /**
     * @return {?}
     */
    LinkularCollapseComponent.prototype.footerCallback = /**
     * @return {?}
     */
    function () {
        this.footer.emit(null);
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularCollapseComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    LinkularCollapseComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    /**
     * @return {?}
     */
    LinkularCollapseComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.showDelete = this.delete.observers.length > 0;
        this.showFooter = this.footer.observers.length > 0;
    };
    LinkularCollapseComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-collapse',
                    template: "<div class=\"linkular-collapse-header\"> <div class=\"linkular-collapse-header-title\" *ngIf=\"!title\"> <input [(ngModel)]=\"model\" (ngModelChange)=\"setValue($event)\" [attr.disabled]=\"(!edit) ? true : null\" type=\"text\" [style.width]=\"( model.length * 1.1 ) + 'rem'\" #title /><button type=\"button\" class=\"linkular-collapse-icon\" (click)=\"toggleEditTitle()\"> <svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" viewBox=\"0 0 200 200\"> <path *ngIf=\"!edit\" d=\"M21.56,184.74l42.26-14.09a5.2,5.2,0,0,0,1.95-1.2L180.63,54.59a15,15,0,0,0,0-21.13L166.54,19.38a14.94,14.94,0,0,0-21.13,0L30.55,134.24a5.08,5.08,0,0,0-1.16,1.83l0,.11L15.26,178.44a5,5,0,0,0,6.3,6.3Zm37.16-36.42a5,5,0,0,0-7-7,5,5,0,0,1-7,0l-3.52-3.52,79.64-79.64,21.13,21.13L62.25,158.89l-3.52-3.52a5,5,0,0,1,0-7ZM134.85,44,156,65.16l-7,7L127.8,51.07Zm17.61-17.61a5,5,0,0,1,7,0l14.09,14.09a5,5,0,0,1,0,7L163,58.12,141.89,37ZM36.25,147l1.35,1.35a14.88,14.88,0,0,0,9.73,4.34,14.83,14.83,0,0,0,4.35,9.74L53,163.76l-25.17,8.39Z\" /> <path *ngIf=\"edit\" d=\"M159.25,39.68a9.22,9.22,0,0,0-13,0l-75,75L53.78,97.23a9.23,9.23,0,0,0-13,0l-13,13a9.21,9.21,0,0,0,0,13l24,24,13,13a9.22,9.22,0,0,0,13,0L172.3,65.76a9.22,9.22,0,0,0,0-13Zm0,0\" /> </svg> </button> </div> <div class=\"linkular-collapse-header-title\" *ngIf=\"title\"> <input [value]=\"title\" type=\"text\" disabled /> </div> <div class=\"linkular-collapse-header-ctrl\"> <button type=\"button\" class=\"linkular-collapse-icon remove\" *ngIf=\"showDelete\" (click)=\"deleteCallback()\"> <svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" viewBox=\"0 0 200 200\"> <path d=\"M159.77,34.92H129.88v-5A15,15,0,0,0,114.94,15H85.06A15,15,0,0,0,70.12,29.94v5H40.23A15,15,0,0,0,25.29,49.86v10a5,5,0,0,0,5,5h5.37l8.76,106.56v0A14.87,14.87,0,0,0,59.29,185h81.42a14.87,14.87,0,0,0,14.88-13.59v0L164.35,64.8h5.37a5,5,0,0,0,5-5v-10A15,15,0,0,0,159.77,34.92Zm-79.69-5a5,5,0,0,1,5-5h29.88a5,5,0,0,1,5,5v5H80.08Zm65.59,140.58a5,5,0,0,1-5,4.51H59.29a5,5,0,0,1-5-4.51L45.64,64.8H154.36ZM164.75,54.84H35.25v-5a5,5,0,0,1,5-5H159.77a5,5,0,0,1,5,5ZM95,150.14V79.75a5,5,0,0,1,10,0v70.39a5,5,0,0,1-10,0Zm29.88,0V79.75a5,5,0,1,1,10,0v70.39a5,5,0,1,1-10,0Zm-59.77,0V79.75a5,5,0,0,1,10,0v70.39a5,5,0,0,1-10,0Z\"/> </svg> </button> <button type=\"button\" class=\"linkular-collapse-icon\" (click)=\"toggle()\"> <svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" viewBox=\"0 0 200 200\"> <path *ngIf=\"!opened\" d=\"M43.59,122.3a4.1,4.1,0,0,0,5.8,0l51-51.1,51.1,51.1a4.1,4.1,0,1,0,5.8-5.8l-53.9-53.9a4,4,0,0,0-2.9-1.2,4.18,4.18,0,0,0-2.9,1.2l-53.9,53.9A4,4,0,0,0,43.59,122.3Z\"/> <path *ngIf=\"opened\" d=\"M157.3,78.6a4.1,4.1,0,0,0-5.8,0l-51,51.1L49.4,78.6a4.1,4.1,0,1,0-5.8,5.8l53.9,53.9a4,4,0,0,0,2.9,1.2,4.18,4.18,0,0,0,2.9-1.2l53.9-53.9A4,4,0,0,0,157.3,78.6Z\"/> </svg> </button> </div> </div> <div class=\"linkular-collapse-body\"> <div class=\"linkular-collapse-content\" *ngIf=\"content\"> <ng-content></ng-content> </div> <div class=\"linkular-collapse-footer\" *ngIf=\"showFooter\" [class.no-content]=\"!content\"> <button type=\"button\" class=\"linkular-collapse-footer-button\" (click)=\"footerCallback()\" [promiseBtn]=\"footerPromise\" translate>{{footerBtnText}}</button> </div> </div> ",
                    styles: [":host { padding: 0; margin-top: 1.5rem; border: 1px solid #d1d1d1; display: block; width: 100%; box-sizing: border-box; -webkit-border-radius: 4px; -moz-border-radius: 4px; -ms-border-radius: 4px; border-radius: 4px; } :host:first-child { margin-top: 0; } :host .linkular-collapse-header { text-align: left; padding: .2rem 1rem 0rem 2rem; background: #fafafa; box-sizing: border-box; height: 3.8rem; -webkit-border-radius: 4px; -moz-border-radius: 4px; -ms-border-radius: 4px; border-radius: 4px; -moz-transition: border-color 0.2s ease; -o-transition: border-color 0.2s ease; -webkit-transition: border-color 0.2s ease; transition: border-color 0.2s ease; } :host .linkular-collapse-header::before, :host .linkular-collapse-header::after { content: \" \"; display: table; clear: both; } :host .linkular-collapse-header input { margin: 0 0 .5rem; padding: .3rem 0 0; line-height: 2.6rem; height: 2.8rem; border: none; width: auto; box-sizing: border-box; min-width: 60px; color: black; max-width: calc(100% - 60px); position: relative; font-size: 1.7rem; background: transparent; font-family: \"Roboto Mono\"; border-bottom: 2px solid black; -webkit-border-radius: 0; -moz-border-radius: 0; -ms-border-radius: 0; border-radius: 0; } :host .linkular-collapse-header input:disabled { opacity: 1; color: black; border-color: transparent; } :host .linkular-collapse-header button.linkular-collapse-icon { border: none; width: 36px; height: 36px; padding: 4px; margin: 0; vertical-align: bottom; } :host .linkular-collapse-header button.linkular-collapse-icon svg { width: 24px; height: 24px; } :host .linkular-collapse-header button.linkular-collapse-icon + button.button.linkular-collapse-icon { margin-left: 20px; } :host .linkular-collapse-header .linkular-collapse-header-title { width: calc(100% - 100px); float: left; } :host .linkular-collapse-header .linkular-collapse-header-ctrl { float: right; width: auto; } :host .linkular-collapse-body { padding: 0; width: 100%; max-height: 0; display: block; overflow: hidden; -moz-transition: max-height 0.25s ease-out; -o-transition: max-height 0.25s ease-out; -webkit-transition: max-height 0.25s ease-out; transition: max-height 0.25s ease-out; } :host .linkular-collapse-body .linkular-collapse-content { padding: 1.5rem 2rem; border-top: 1px solid #d1d1d1; width: 100%; display: block; } :host .linkular-collapse-body .linkular-collapse-footer { border-top: 1px solid #d1d1d1; height: 50px; box-sizing: border-box; width: 100%; } :host .linkular-collapse-body .linkular-collapse-footer button.linkular-collapse-footer-button { display: block; float: right; color: black; margin: 0; height: 49px; line-height: 49px; min-width: 160px; background: #fafafa; border-color: #fafafa; box-sizing: border-box; border-left: 1px solid #d1d1d1; -webkit-border-radius: 0 4px 4px 0; -moz-border-radius: 0 4px 4px 0; -ms-border-radius: 0 4px 4px 0; border-radius: 0 4px 4px 0; } :host .linkular-collapse-body .linkular-collapse-footer.no-content { border-top: none; } :host.changed { border-color: black; } :host.changed .linkular-collapse-header { border-color: black; } :host.error { border-color: #FF8A80; } :host.success { border-color: #1DE9B6; } :host.opened .linkular-collapse-header { -webkit-border-radius: 4px 4px 0 0; -moz-border-radius: 4px 4px 0 0; -ms-border-radius: 4px 4px 0 0; border-radius: 4px 4px 0 0; -moz-transition: border-color 0.2s ease; -o-transition: border-color 0.2s ease; -webkit-transition: border-color 0.2s ease; transition: border-color 0.2s ease; } :host.opened .linkular-collapse-body { overflow: visible; max-height: 2000px; -moz-transition: max-height 0.3s ease-in; -o-transition: max-height 0.3s ease-in; -webkit-transition: max-height 0.3s ease-in; transition: max-height 0.3s ease-in; } form.submitted :host.ng-invalid .linkular-collapse-header input { opacity: 1; color: #FF8A80; border-color: #FF8A80; } "],
                    host: {
                        '[class.error]': 'error',
                        '[class.success]': 'success',
                        '[class.changed]': 'changed',
                        '[class.opened]': 'opened'
                    },
                    providers: [
                        LINKULAR_COLLAPSE_ACCESSOR
                    ]
                },] },
    ];
    /** @nocollapse */
    LinkularCollapseComponent.propDecorators = {
        "el": [{ type: core.ViewChild, args: ['title',] },],
        "opened": [{ type: core.Input },],
        "title": [{ type: core.Input },],
        "content": [{ type: core.Input },],
        "error": [{ type: core.Input },],
        "success": [{ type: core.Input },],
        "changed": [{ type: core.Input },],
        "delete": [{ type: core.Output },],
        "footer": [{ type: core.Output },],
        "footerBtnText": [{ type: core.Input },],
        "footerPromise": [{ type: core.Input },],
    };
    return LinkularCollapseComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularCollapseModule = /** @class */ (function () {
    function LinkularCollapseModule() {
    }
    LinkularCollapseModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        dist.Angular2PromiseButtonModule,
                        core$1.TranslateModule
                    ],
                    declarations: [
                        LinkularCollapseComponent
                    ],
                    exports: [
                        LinkularCollapseComponent
                    ]
                },] },
    ];
    return LinkularCollapseModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

(function (LinkularGraphChart) {
    LinkularGraphChart.addZero = function (x) { return (x < 10) ? ('0' + x) : x; };
    /**
     * @param {?} value
     * @return {?}
     */
    function getColor(value) {
        // value from 0 to 1
        var /** @type {?} */ hue = (value * 120).toString(10);
        return ['hsl(', hue, ',100%,50%)'].join('');
    }
    LinkularGraphChart.getColor = getColor;
    /**
     * @param {?} num
     * @param {?} high
     * @param {?} low
     * @return {?}
     */
    function calculateNPS(num, high, low) {
        return (num >= high) ? 1 : ((num <= low) ? 0 : 0.5);
    }
    LinkularGraphChart.calculateNPS = calculateNPS;
    /**
     * @param {?} _num
     * @param {?} _min
     * @param {?} _max
     * @return {?}
     */
    function oneScaleValueCalculator(_num, _min, _max) {
        var /** @type {?} */ minAllowed = 0;
        var /** @type {?} */ maxAllowed = 1;
        return (maxAllowed - minAllowed) * (_num - _min) / (_max - _min) + minAllowed;
    }
    LinkularGraphChart.oneScaleValueCalculator = oneScaleValueCalculator;
})(exports.LinkularGraphChart || (exports.LinkularGraphChart = {}));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

(function (LinkularGraphBarChart) {
    var /** @type {?} */ height, /** @type {?} */ width, /** @type {?} */ chartHeight, /** @type {?} */ chartWidth, /** @type {?} */ margin;
    var /** @type {?} */ svg, /** @type {?} */ chartLayer, /** @type {?} */ axisLayer, /** @type {?} */ xScale, /** @type {?} */ yScale;
    var /** @type {?} */ data, /** @type {?} */ series, /** @type {?} */ max, /** @type {?} */ seriesType, /** @type {?} */ orientation;
    var /** @type {?} */ minScale = 0, /** @type {?} */ maxScale, /** @type {?} */ low, /** @type {?} */ high;
    var /** @type {?} */ options;
    /**
     * @param {?} el
     * @param {?} graph
     * @param {?} all
     * @return {?}
     */
    function main(el, graph, all) {
        margin = { top: 15, left: 25, bottom: 25, right: 10 };
        height = el.nativeElement.clientHeight;
        width = el.nativeElement.clientWidth;
        data = all.data;
        series = all.series;
        minScale = all.min;
        max = all.max;
        seriesType = all.seriesType;
        orientation = all.orientation;
        options = all.options;
        svg = d3.select(graph.nativeElement)
            .html('')
            .classed('barChart', true);
        setSize();
        if (orientation === 'VERTICAL') {
            drawAxis();
            drawChartVertical();
        }
        else {
            // TO BE CREATED
        }
    }
    LinkularGraphBarChart.main = main;
    /**
     * @param {?} el
     * @param {?} graph
     * @param {?} all
     * @return {?}
     */
    function grades(el, graph, all) {
        margin = { top: 10, left: 20, bottom: 10, right: 10 };
        height = el.nativeElement.clientHeight;
        width = el.nativeElement.clientWidth;
        data = all.data;
        seriesType = 'NUMBER';
        minScale = all.min;
        maxScale = all.max;
        low = all.low;
        high = all.high;
        max = data.reduce(function (sum, x) { return sum + x; }, 0);
        var /** @type {?} */ newSeries = [];
        for (var /** @type {?} */ i = minScale; i <= maxScale; i++) {
            newSeries.push(i);
        }
        series = newSeries;
        svg = d3.select(graph.nativeElement)
            .html('')
            .classed('barChartGrades', true);
        setSize(true);
        drawAxis(false, true);
        drawChartForGrades();
    }
    LinkularGraphBarChart.grades = grades;
    /**
     * @param {?=} inverse
     * @return {?}
     */
    function setSize(inverse) {
        if (inverse === void 0) { inverse = false; }
        axisLayer = svg.append('g')
            .classed('axisLayer', true);
        chartLayer = svg.append('g')
            .classed('chartLayer', true);
        if (inverse) {
            xScale = d3.scaleLinear();
            yScale = d3.scaleBand();
        }
        else {
            xScale = d3.scaleBand();
            yScale = d3.scaleLinear();
        }
        chartWidth = width - (margin.left + margin.right);
        chartHeight = height - (margin.top + margin.bottom);
        svg.attr('width', width)
            .attr('height', height);
        chartLayer
            .attr('width', chartWidth)
            .attr('height', chartHeight)
            .attr('transform', 'translate(' + [margin.left, margin.top] + ')');
        var /** @type {?} */ maxValue, /** @type {?} */ maxArray;
        if (inverse) {
            max = (max) ? max : 1;
            xScale.domain([0, max]).range([0, chartWidth]);
            yScale.domain(series).range([chartHeight, minScale]).padding(0.1);
        }
        else {
            maxArray = data.slice().map(function (x) { return Math.max.apply(Math, x.data); });
            maxValue = (max && !isNaN(max)) ? max : Math.max.apply(Math, maxArray);
            xScale.domain(series).range([0, chartWidth]).paddingInner(0.2);
            yScale.domain([minScale, maxValue]).range([chartHeight, minScale]);
        }
    }
    /**
     * @return {?}
     */
    function drawChartVertical() {
        var /** @type {?} */ barWidth = xScale.bandwidth() / data.length;
        // TRANSITION SETTINGS
        var /** @type {?} */ t = d3.transition().duration(400).ease(d3.easeBackOut);
        var /** @type {?} */ t2 = d3.transition().duration(400).ease(d3.easeLinear);
        // GROUP Element
        var /** @type {?} */ group = chartLayer.selectAll('.group')
            .data(data);
        var /** @type {?} */ singleGroup = group.enter()
            .append('g')
            .classed('group', true)
            .attr('value', function (x) { return x.label; });
        group.merge(singleGroup)
            .attr('transform', function (x, i) { return 'translate(' + (i * barWidth) + ',0)'; });
        // BAR Element
        var /** @type {?} */ barGroup = singleGroup.selectAll('.bar')
            .data(function (x, i) { return x.data.map(function (y) { return ({ value: y, color: x.color, label: x.label, index: i }); }); });
        var /** @type {?} */ barRect = barGroup.enter()
            .append('rect')
            .attr('class', 'bar');
        barGroup.merge(barRect)
            .attr('value', function (x, i) { return series[i]; })
            .attr('width', barWidth)
            .attr('height', 0)
            .attr('fill', function (x) { return x.color; })
            .attr('opacity', 0.95)
            .attr('transform', function (x, i, el) { return 'translate(' + [xScale(series[i]), chartHeight] + ')'; })
            .transition(t)
            .delay(function (x, i) { return i * 75 + 200; })
            .attr('height', function (x, i) { return (chartHeight - yScale(x.value) > 0) ? chartHeight - yScale(x.value) : 0; })
            .attr('transform', function (x, i) { return 'translate(' + [xScale(series[i]), yScale(x.value)] + ')'; });
        // TEXT Element
        if (!options || !options.mini) {
            var /** @type {?} */ barText = singleGroup.selectAll('.bar-text')
                .data(function (x, i) { return x.data.map(function (y) { return ({ value: y, color: x.color, label: x.label, index: i }); }); });
            var /** @type {?} */ newText = barGroup.enter()
                .append('text')
                .attr('class', 'bar-text')
                .attr('text-anchor', 'middle');
            barText.merge(newText)
                .attr('value', function (x, i) { return series[i]; })
                .attr('x', function (x, i) { return xScale(series[i]) + barWidth / 2; })
                .attr('y', function (x) { return yScale(x.value) - 5; })
                .attr('opacity', 0)
                .text(function (x) { return (x.value === 0) ? '' : x.value.toFixed(2).toString(); })
                .transition(t2)
                .delay(function (x, i) { return i * 100 + 200; })
                .attr('opacity', (data.length > 2) ? 0 : 1);
        }
    }
    /**
     * @return {?}
     */
    function drawChartForGrades() {
        // TRANSITION SETTINGS
        var /** @type {?} */ t = d3.transition().duration(200).ease(d3.easeLinear);
        // GROUP Element
        var /** @type {?} */ group = chartLayer.selectAll('.group')
            .data(data);
        var /** @type {?} */ singleGroup = group.enter()
            .append('g')
            .classed('group', true)
            .attr('value', function (x, i) { return 'Score ' + series[i]; });
        group.merge(singleGroup)
            .attr('transform', function (x, i) { return 'translate(0,0)'; });
        // BAR Element Process
        var /** @type {?} */ barGroupFull = singleGroup.selectAll('.bar')
            .data(function (x, i) { return [i]; });
        var /** @type {?} */ barRectFull = barGroupFull.enter()
            .append('rect')
            .attr('class', 'bar-grade-full');
        barGroupFull.merge(barRectFull)
            .attr('height', yScale.bandwidth())
            .attr('x', 0)
            .attr('y', function (x) { return yScale(series[x]); })
            .attr('width', xScale(max))
            .attr('fill', '#dddddd')
            .attr('opacity', .4);
        var /** @type {?} */ barGroup = singleGroup.selectAll('.bar')
            .data(function (x, i) { return [{ value: x, index: i }]; });
        var /** @type {?} */ barRect = barGroup.enter()
            .append('rect')
            .attr('class', 'bar-grade-active');
        barGroup.merge(barRect)
            .attr('height', yScale.bandwidth())
            .attr('x', 0)
            .attr('y', function (x) { return yScale(series[x.index]); })
            .attr('width', 0)
            .attr('fill', function (x) {
            var /** @type {?} */ val = (low && high) ?
                exports.LinkularGraphChart.calculateNPS(series[x.index], high, low) :
                exports.LinkularGraphChart.oneScaleValueCalculator(series[x.index], minScale, maxScale);
            return exports.LinkularGraphChart.getColor(val);
        })
            .transition(t)
            .delay(function (x, i) { return i * 75 + 125; })
            .attr('width', function (x) { return xScale(x.value); });
        // TEXT Element
        var /** @type {?} */ barText = singleGroup.selectAll('.bar-text')
            .data(function (x, i) { return [{ value: x, index: i }]; });
        var /** @type {?} */ newText = barGroup.enter()
            .append('text')
            .attr('class', 'bar-text')
            .attr('text-anchor', 'middle');
        barText.merge(newText)
            .attr('value', function (x) { return series[x.index]; })
            .attr('x', xScale(max) - 10)
            .attr('y', function (x) { return yScale(series[x.index]) + 4 + yScale.bandwidth() / 2; })
            .attr('text-anchor', 'end')
            .attr('opacity', 1)
            .text(function (x) { return (x.value === 0) ? '0 (0%)' : x.value + ' (' + parseFloat((x.value * 100 / max).toFixed(2)) + '%)'; });
    }
    /**
     * @param {?=} x
     * @param {?=} y
     * @return {?}
     */
    function drawAxis(x, y) {
        if (x === void 0) { x = true; }
        if (y === void 0) { y = true; }
        if (x) {
            var /** @type {?} */ xAxis = d3.axisBottom(xScale);
            axisLayer.append('g')
                .attr('class', 'axisX')
                .attr('transform', 'translate(' + [margin.left, chartHeight + margin.top] + ')')
                .call(xAxis.tickFormat(setLabel));
        }
        if (y) {
            var /** @type {?} */ yAxis = d3.axisLeft(yScale)
                .tickSizeInner(-chartWidth)
                .tickFormat(function (e) {
                if (Math.floor(e) !== e) {
                    return;
                }
                return e;
            });
            axisLayer.append('g')
                .attr('transform', 'translate(' + [margin.left, margin.top] + ')')
                .attr('class', 'axisY')
                .call(yAxis);
        }
    }
    // HELPERS
    var /** @type {?} */ setLabel = function (x, i) {
        var /** @type {?} */ out = '';
        var /** @type {?} */ td;
        if (series.length > 12 && options && options.mini && i % 3 !== 0) {
            return;
        }
        switch (seriesType) {
            case 'HOUR':
                td = new Date(x);
                out = td.getHours();
                break;
            case 'DAY':
                td = new Date(x);
                out = td.getDate();
                break;
            case 'WEEK':
                td = new Date(x);
                var /** @type {?} */ firstJan = new Date(td.getFullYear(), 0, 1);
                out = Math.ceil((((td - firstJan) / 86400000) + firstJan.getDay() + 1) / 7) + '';
                break;
            case 'MONTH':
                td = new Date(x);
                out = td.getMonth() + 1;
                break;
            default:
                out = x;
        }
        return out;
    };
})(exports.LinkularGraphBarChart || (exports.LinkularGraphBarChart = {}));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var duration = 250;
var lineOpacity = '0.4';
var lineOpacityHover = '0.85';
var otherLinesOpacityHover = '0.1';
var circleOpacity = '0.85';
var circleOpacityOnLineHover = '0.25';
var circleRadius = 3;
var circleRadiusHover = 5;

(function (LinkularGraphLineChart) {
    var /** @type {?} */ height, /** @type {?} */ width, /** @type {?} */ chartHeight, /** @type {?} */ chartWidth, /** @type {?} */ margin;
    var /** @type {?} */ svg, /** @type {?} */ chartLayer, /** @type {?} */ axisLayer, /** @type {?} */ xScale, /** @type {?} */ yScale;
    var /** @type {?} */ data, /** @type {?} */ series, /** @type {?} */ max, /** @type {?} */ seriesType;
    var /** @type {?} */ minScale = 0;
    var /** @type {?} */ options;
    var /** @type {?} */ line$$1;
    /**
     * @param {?} el
     * @param {?} graph
     * @param {?} all
     * @return {?}
     */
    function main(el, graph, all) {
        height = el.nativeElement.clientHeight;
        width = el.nativeElement.clientWidth;
        margin = { top: 30, left: 25, bottom: 25, right: 10 };
        data = all.data;
        series = all.series;
        minScale = all.min;
        max = all.max;
        seriesType = all.seriesType;
        options = all.options;
        svg = d3.select(graph.nativeElement)
            .html('')
            .classed('lineChart', true);
        setSize();
        drawAxis();
        drawChartData();
    }
    LinkularGraphLineChart.main = main;
    /**
     * @return {?}
     */
    function setSize() {
        axisLayer = svg.append('g')
            .classed('axisLayer', true);
        chartLayer = svg.append('g')
            .classed('chartLayer', true);
        xScale = d3.scaleBand();
        yScale = d3.scaleLinear();
        chartWidth = width - (margin.left + margin.right);
        chartHeight = height - (margin.top + margin.bottom);
        svg.attr('width', width)
            .attr('height', height);
        chartLayer
            .attr('width', chartWidth)
            .attr('height', chartHeight)
            .attr('transform', 'translate(' + [margin.left, margin.top] + ')');
        var /** @type {?} */ maxValue, /** @type {?} */ maxArray;
        maxArray = data.slice().map(function (x) { return Math.max.apply(Math, x.data); });
        maxValue = (max && !isNaN(max)) ? max : Math.max.apply(Math, maxArray);
        xScale.domain(series).range([0, chartWidth]).paddingInner(0.2);
        yScale.domain([minScale, maxValue]).range([chartHeight, minScale]);
        line$$1 = d3.line()
            .x(function (x, i) { return xScale(series[i]) + xScale.bandwidth() / 2; })
            .y(function (x) { return yScale(x); });
    }
    /**
     * @return {?}
     */
    function drawChartData() {
        var /** @type {?} */ group = chartLayer.selectAll('.line-group')
            .data(data);
        var /** @type {?} */ singleGroup = group.enter()
            .append('g')
            .classed('line-group', true)
            .attr('value', function (x) { return x.label; });
        var /** @type {?} */ singleLine = singleGroup.enter()
            .append('g')
            .attr('class', 'single-line')
            .attr('value', function (x) { return x.label; });
        singleGroup.merge(singleLine)
            .on('mouseover', function (x) {
            chartLayer.append('text')
                .attr('class', 'title-text')
                .style('fill', x.color)
                .text(x.label)
                .attr('text-anchor', 'middle')
                .attr('x', chartWidth / 2)
                .attr('y', -8);
        })
            .on('mouseout', function () {
            chartLayer.select('.title-text').remove();
        })
            .append('path')
            .attr('class', 'single-line')
            .attr('d', function (x) { return line$$1(x.data); })
            .style('stroke', function (x) { return x.color; })
            .style('opacity', lineOpacity)
            .on('mouseover', function () {
            d3.selectAll('.single-line')
                .style('opacity', otherLinesOpacityHover);
            d3.selectAll('.single-circle')
                .style('opacity', circleOpacityOnLineHover);
            d3.select(this)
                .style('opacity', lineOpacityHover)
                .style('cursor', 'pointer');
        })
            .on('mouseout', function () {
            d3.selectAll('.single-line')
                .style('opacity', lineOpacity);
            d3.selectAll('.single-circle')
                .style('opacity', circleOpacity);
            d3.select(this)
                .style('cursor', 'none');
        });
        var /** @type {?} */ singleCircle = chartLayer.selectAll('.circle-group')
            .data(data).enter()
            .append('g')
            .classed('circle-group', true)
            .attr('value', function (x) { return x.label; })
            .style('fill', function (x) { return x.color; })
            .selectAll('.single-circle')
            .data(function (d) { return d.data; }).enter()
            .append('g')
            .attr('class', 'single-circle')
            .on('mouseover', function (x, i) {
            d3.select(this)
                .style('cursor', 'pointer')
                .append('text')
                .attr('class', 'text')
                .text("" + x)
                .attr('x', xScale(series[i]) + 10 + xScale.bandwidth() / 2)
                .attr('y', yScale(x) - 10);
        })
            .on('mouseout', function () {
            d3.select(this)
                .style('cursor', 'none')
                .transition()
                .duration(duration)
                .selectAll('.text').remove();
        })
            .append('circle')
            .attr('cx', function (x, i) { return xScale(series[i]) + xScale.bandwidth() / 2; })
            .attr('cy', function (x) { return yScale(x); })
            .attr('r', circleRadius)
            .style('opacity', circleOpacity)
            .on('mouseover', function () {
            d3.select(this)
                .transition()
                .duration(duration)
                .attr('r', circleRadiusHover);
        })
            .on('mouseout', function () {
            d3.select(this)
                .transition()
                .duration(duration)
                .attr('r', circleRadius);
        });
    }
    /**
     * @return {?}
     */
    function drawAxis() {
        var /** @type {?} */ xAxis = d3.axisBottom(xScale);
        axisLayer.append('g')
            .attr('class', 'axisX')
            .attr('transform', 'translate(' + [margin.left, chartHeight + margin.top] + ')')
            .call(xAxis.tickFormat(setLabel));
        var /** @type {?} */ yAxis = d3.axisLeft(yScale)
            .tickSizeInner(-chartWidth)
            .tickFormat(function (e) {
            if (Math.floor(e) !== e) {
                return;
            }
            return e;
        });
        axisLayer.append('g')
            .attr('transform', 'translate(' + [margin.left, margin.top] + ')')
            .attr('class', 'axisY')
            .call(yAxis);
    }
    var /** @type {?} */ setLabel = function (x, i) {
        var /** @type {?} */ out = '';
        var /** @type {?} */ td;
        if (series.length > 12 && options && options.mini && i % 3 !== 0) {
            return;
        }
        switch (seriesType) {
            case 'HOUR':
                td = new Date(x);
                out = td.getHours();
                break;
            case 'DAY':
                td = new Date(x);
                out = td.getDate();
                break;
            case 'WEEK':
                td = new Date(x);
                var /** @type {?} */ firstJan = new Date(td.getFullYear(), 0, 1);
                out = Math.ceil((((td - firstJan) / 86400000) + firstJan.getDay() + 1) / 7) + '';
                break;
            case 'MONTH':
                td = new Date(x);
                out = td.getMonth() + 1;
                break;
            default:
                out = x;
        }
        return out;
    };
})(exports.LinkularGraphLineChart || (exports.LinkularGraphLineChart = {}));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularGraphComponent = /** @class */ (function () {
    function LinkularGraphComponent(el) {
        this.el = el;
        this.loading = true;
        this.data = [];
        this.series = [];
        this.colors = ['#fdba37', '#fd4337', '#475eac', '#afecf3'];
    }
    /**
     * @return {?}
     */
    LinkularGraphComponent.prototype.chartCenter = /**
     * @return {?}
     */
    function () {
        this.loading = false;
        if (this.data) {
            var /** @type {?} */ data = void 0;
            switch (this.type) {
                case 'aster-plot':
                    // this.createChartAsterPlot();
                    break;
                case 'bar-grades':
                    data = {
                        data: this.data.slice(),
                        min: this.min,
                        max: this.max,
                        low: (this.options.scaleType === 'NPS' && this.options.low) ? this.options.low : null,
                        high: (this.options.scaleType === 'NPS' && this.options.high) ? this.options.high : null
                    };
                    exports.LinkularGraphBarChart.grades(this.el, this.graph, data);
                    break;
                case 'bar':
                    data = {
                        data: this.data.slice(),
                        series: this.series.slice(),
                        min: this.min,
                        max: this.max,
                        seriesType: this.seriesType,
                        orientation: 'VERTICAL',
                        options: this.options
                    };
                    exports.LinkularGraphBarChart.main(this.el, this.graph, data);
                    break;
                case 'line':
                    data = {
                        data: this.data.slice(),
                        series: this.series.slice(),
                        min: this.min,
                        max: this.max,
                        seriesType: this.seriesType,
                        orientation: 'VERTICAL',
                        options: this.options
                    };
                    exports.LinkularGraphLineChart.main(this.el, this.graph, data);
                    break;
                case 'donut':
                    // this.createChartDonut();
                    break;
                default:
                    console.log('Invalid Linkular Graph type');
            }
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    LinkularGraphComponent.prototype.onResize = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (!this.loading) {
            this.chartCenter();
        }
    };
    /**
     * @return {?}
     */
    LinkularGraphComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        var _this = this;
        setTimeout(function () {
            _this.chartCenter();
        }, 500);
    };
    LinkularGraphComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'linkular-graph',
                    template: "<!-- <div class=\"graph-loading\" *ngIf=\"loading\">Loading...</div> --> <svg #graphElement></svg>",
                    styles: [":host { position: relative; } :host svg.barChartGrades, :host svg.barChart { margin: 0 auto; } :host .graph-loading { position: absolute; display: block; top: 0; left: 0; width: 100%; height: 100%; text-align: center; } "]
                },] },
    ];
    /** @nocollapse */
    LinkularGraphComponent.ctorParameters = function () { return [
        { type: core.ElementRef, },
    ]; };
    LinkularGraphComponent.propDecorators = {
        "data": [{ type: core.Input },],
        "series": [{ type: core.Input },],
        "seriesType": [{ type: core.Input },],
        "type": [{ type: core.Input },],
        "colors": [{ type: core.Input },],
        "min": [{ type: core.Input },],
        "max": [{ type: core.Input },],
        "options": [{ type: core.Input },],
        "graph": [{ type: core.ViewChild, args: ['graphElement',] },],
        "onResize": [{ type: core.HostListener, args: ['window:resize', ['$event'],] },],
    };
    return LinkularGraphComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

(function (LinkularGraphGeneral) {
    /**
     * @param {?} native
     * @param {?} graph
     * @param {?} type
     * @return {?}
     */
    function setSize(native, graph, type) {
        var /** @type {?} */ height = native.nativeElement.clientHeight;
        var /** @type {?} */ width = native.nativeElement.clientWidth;
        return d3.select(graph.nativeElement)
            .html('')
            .classed(type, true);
    }
    LinkularGraphGeneral.setSize = setSize;
})(exports.LinkularGraphGeneral || (exports.LinkularGraphGeneral = {}));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularGraphModule = /** @class */ (function () {
    function LinkularGraphModule() {
    }
    LinkularGraphModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        core$1.TranslateModule
                    ],
                    declarations: [
                        LinkularGraphComponent
                    ],
                    exports: [
                        LinkularGraphComponent
                    ]
                },] },
    ];
    return LinkularGraphModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LinkularModule = /** @class */ (function () {
    function LinkularModule() {
    }
    LinkularModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        LinkularFormModule,
                        LinkularInfiniteModule,
                        LinkularCollapseModule,
                        LinkularGraphModule
                    ],
                    exports: [
                        LinkularInfiniteModule,
                        LinkularFormModule,
                        LinkularCollapseModule,
                        LinkularGraphModule
                    ]
                },] },
    ];
    return LinkularModule;
}());

exports.LinkularModule = LinkularModule;
exports.LinkularFormModule = LinkularFormModule;
exports.LINKULAR_INPUT_VALUE_ACCESSOR = LINKULAR_INPUT_VALUE_ACCESSOR;
exports.LinkularInputComponent = LinkularInputComponent;
exports.LINKULAR_WITH_ADDON_ACCESSOR = LINKULAR_WITH_ADDON_ACCESSOR;
exports.LinkularInputAddonComponent = LinkularInputAddonComponent;
exports.LINKULAR_CHECKBOX_VALUE_ACCESSOR = LINKULAR_CHECKBOX_VALUE_ACCESSOR;
exports.LinkularCheckboxComponent = LinkularCheckboxComponent;
exports.LINKULAR_TEXTAREA_VALUE_ACCESSOR = LINKULAR_TEXTAREA_VALUE_ACCESSOR;
exports.LinkularTextareaComponent = LinkularTextareaComponent;
exports.SMSCounterComponent = SMSCounterComponent;
exports.LINKULAR_SELECT_VALUE_ACCESSOR = LINKULAR_SELECT_VALUE_ACCESSOR;
exports.LinkularSelectComponent = LinkularSelectComponent;
exports.LINKULAR_SELECT_LANGUAGE_ACCESSOR = LINKULAR_SELECT_LANGUAGE_ACCESSOR;
exports.LinkularSelectLanguageComponent = LinkularSelectLanguageComponent;
exports.LINKULAR_SELECT_LANGUAGE2_ACCESSOR = LINKULAR_SELECT_LANGUAGE2_ACCESSOR;
exports.LinkularSelectLanguage2Component = LinkularSelectLanguage2Component;
exports.LINKULAR_SELECT_TRANSLATE_ACCESSOR = LINKULAR_SELECT_TRANSLATE_ACCESSOR;
exports.LinkularSelectTranslateComponent = LinkularSelectTranslateComponent;
exports.LinkularColorpickerComponent = LinkularColorpickerComponent;
exports.LINKULAR_DURATION_ACCESSOR = LINKULAR_DURATION_ACCESSOR;
exports.LinkularDurationComponent = LinkularDurationComponent;
exports.LINKULAR_TIME_ACCESSOR = LINKULAR_TIME_ACCESSOR;
exports.LinkularTimeComponent = LinkularTimeComponent;
exports.LINKULAR_COUNTRYCODE_VALUE_ACCESSOR = LINKULAR_COUNTRYCODE_VALUE_ACCESSOR;
exports.LinkularCountryCodeComponent = LinkularCountryCodeComponent;
exports.LINKULAR_PHONE_VALUE_ACCESSOR = LINKULAR_PHONE_VALUE_ACCESSOR;
exports.LinkularPhoneNumberComponent = LinkularPhoneNumberComponent;
exports.LINKULAR_SWITCH_ACCESSOR = LINKULAR_SWITCH_ACCESSOR;
exports.LinkularSwitchComponent = LinkularSwitchComponent;
exports.LinkularErrorDirective = LinkularErrorDirective;
exports.LinkularErrorMsgDirective = LinkularErrorMsgDirective;
exports.LinkularInfiniteModule = LinkularInfiniteModule;
exports.LinkularCollapseModule = LinkularCollapseModule;
exports.LINKULAR_COLLAPSE_ACCESSOR = LINKULAR_COLLAPSE_ACCESSOR;
exports.LinkularCollapseComponent = LinkularCollapseComponent;
exports.LinkularGraphModule = LinkularGraphModule;
exports.LinkularGraphComponent = LinkularGraphComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
